
This is a patch file against 0.2.3.

Change to directory g10-0.2.3 (or however you renamed it)
and give this command:

     zcat somepath/g10-0.2.4.diff.gz | patch -p1

It is a good idea to rename your current directory to g10-0.2.4 now.



Prereq: 0.2.3

diff -urN g10-0.2.3/VERSION g10-0.2.4/VERSION
--- g10-0.2.3/VERSION	Mon Feb  9 18:01:08 1998
+++ g10-0.2.4/VERSION	Wed Feb 11 23:13:43 1998
@@ -1 +1 @@
-0.2.3
+0.2.4
diff -urN g10-0.2.3/ChangeLog g10-0.2.4/ChangeLog
--- g10-0.2.3/ChangeLog	Tue Nov 18 11:00:09 1997
+++ g10-0.2.4/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/Makefile.in g10-0.2.4/Makefile.in
--- g10-0.2.3/Makefile.in	Mon Feb  9 18:04:27 1998
+++ g10-0.2.4/Makefile.in	Wed Feb 11 23:19:38 1998
@@ -93,8 +93,8 @@
 CONFIG_HEADER = config.h
 CONFIG_CLEAN_FILES = 
 DIST_COMMON =  README ABOUT-NLS AUTHORS COPYING ChangeLog INSTALL \
-Makefile.am Makefile.in NEWS TODO acconfig.h acinclude.m4 aclocal.m4 \
-config.h.in configure configure.in stamp-h.in
+Makefile.am Makefile.in NEWS THANKS TODO acconfig.h acinclude.m4 \
+aclocal.m4 config.h.in configure configure.in stamp-h.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
diff -urN g10-0.2.3/NEWS g10-0.2.4/NEWS
--- g10-0.2.3/NEWS	Mon Feb  9 15:11:33 1998
+++ g10-0.2.4/NEWS	Wed Feb 11 23:12:09 1998
@@ -1,3 +1,17 @@
+Noteworthy changes in version 0.2.x
+***********************************
+
+    * nearly doubled the speed of the ElGamal signature verification.
+
+    * backup copies of keyrings are created.
+
+    * assembler stuff for Pentium; gives about 15% better perfomance.
+
+    * fixed a lot of bugs.
+
+
+Noteworthy changes in version 0.2.3
+***********************************
 
     * Found a bug in the calculation of ELG fingerprints. This is now
       fixed, but all existing fingerprints and keyids for ELG keys
diff -urN g10-0.2.3/THANKS g10-0.2.4/THANKS
--- g10-0.2.3/THANKS	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/THANKS	Tue Feb 10 14:22:16 1998
@@ -0,0 +1,26 @@
+G10 has originally been written by Werner Koch.  Other people contributed
+by reporting problems, suggesting various improvements or submitting actual
+code.  Here is a list of these people.	Help me keeping it complete and
+exempt of errors.
+
+
+Anand Kumria		wildfire@progsoc.uts.edu.au
+Daniel Eisenbud 	eisenbud@cs.swarthmore.edu
+Detlef Lannert		lannert@lannert.rz.uni-duesseldorf.de
+Ernst Molitor		ernst.molitor@uni-bonn.de
+Hendrik Buschkamp	buschkamp@rheumanet.org
+Jens Bachem		bachem@rrz.uni-koeln.de
+Peter Gutmann		pgut001@cs.auckland.ac.nz
+Ralph Gillen		gillen@theochem.uni-duesseldorf.de
+Thomas Roessler 	roessler@guug.de
+Tomas Fasth		tomas.fasth@twinspot.net
+Walter Koch		walterk@ddorf.rhein-ruhr.de
+Werner Koch		werner.koch@guug.de
+Wim Vandeputte		bunbun@reptile.rug.ac.be
+
+
+Thanks to the German Unix User Group for providing FTP space and
+Martin Hamilton for hosting the mailing list.
+
+Many thanks to Gerlinde for having so much patience with me while
+hacking late in the evening.
diff -urN g10-0.2.3/TODO g10-0.2.4/TODO
--- g10-0.2.3/TODO	Tue Feb  3 13:15:19 1998
+++ g10-0.2.4/TODO	Wed Feb 11 23:13:23 1998
@@ -1,10 +1,8 @@
 
-    * add assembler support for more CPUs. (work, but easy)
     * improve iobuf by reading more than one byte at once,
       this shoud espceially done for the buffer in the chain.
     * add a way to difference between errors and eof in the underflow/flush
       function of iobuf.
-    * check that all output is filtered when displayed.
     * add checking of armor trailers
     * look for a way to reuse RSA signatures
     * remove all "Fixmes"
@@ -15,8 +13,6 @@
     * complete cipher/cast.c
     * complete cipher/dsa.c
 
-    * armor has now some problems.
-
     * add g10 stuff to Mutt's pgpinvoke.c
 
     * Burn the buffers used by fopen().
@@ -26,8 +22,5 @@
       and mark them as valid/invalid/nopubkey, and how do we check, that
       we have a self-signature -> put this stuff into a kind of directory
       record, as it does not belong to the pubkey record?
-
-    * Have no prototype for stpcpy() when using glibc 2; must switch on
-      the GNU extensions or see how configure can fix it.
 
 
diff -urN g10-0.2.3/checks/checkit g10-0.2.4/checks/checkit
--- g10-0.2.3/checks/checkit	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/checks/checkit	Wed Feb 11 23:08:06 1998
@@ -0,0 +1,184 @@
+#!/bin/bash
+#  Script for G10 testing
+#---------------------------------------------------------
+
+#--------------------------------
+#------ constants ---------------
+#--------------------------------
+
+usrname1="one"
+usrpass1="def"
+usrname2="two"
+usrpass2="abc"
+plain_files="plain-1 plain-2 plain-3"
+data_files=""
+exp_files=""
+last_command=""
+
+
+#--------------------------------
+#------ utility functions -------
+#--------------------------------
+
+fatal () {
+    echo "$pgmname: fatal:" $* >&2
+    exit 1;
+}
+
+error () {
+    echo "$pgmname:" $* >&2
+    echo "($last_command) failed" >&2
+    exit 1
+}
+
+info () {
+    echo "$pgmname:" $* >&2
+}
+
+chdir () {
+    cd $1 || fatal "cannot cd to $1"
+}
+
+run_g10 () {
+    last_command="HOME=. ../g10/g10 $*"
+    eval HOME=. ../g10/g10 $*
+}
+
+#--------------------------------
+#-------- main program ----------
+#--------------------------------
+
+set -e
+pgmname=$(basename $0)
+
+# some checks
+[ -d "./.g10" ] || fatal "subdirectory .g10 missing"
+for i in $plain_files; do
+    [ -f $i ] || fatal "$i: missing"
+done
+for i in $exp_files; do
+    [ -f $i ] || fatal "$i: script missing"
+done
+
+cat <<EOF  >./.g10/options
+no-greeting
+no-secmem-warning
+batch
+EOF
+
+# print the G10 version
+run_g10 --version
+
+info Checking cleartext signatures
+# There is a minor glitch, which appends a lf to the cleartext.
+# I do not consider that a bug, but I have to use the head .. mimic.
+# It is not clear what should happen to leading LFs, we must
+# change the defintion of cleartext, so that only 1 empty line
+# must follow the headers, but some specs say: any number of empty lines ..
+# clean-sat removes leading LFs
+# I know that this does not work for random data files (due to large lines
+# or what ever) - I hope we can live with it.
+for i in $plain_files; do
+    echo "$usrpass1" | run_g10 --passphrase-fd 0 -sat -o x --yes $i || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    ../tools/clean-sat < $i > z
+    head -c $[ $(cat y | wc -c) - 1 ] y | diff - z || error "$i: mismatch"
+done
+
+info Creating some random data files
+for i in 500 9000 32000 80000; do
+    head -c $i /dev/urandom >data-$i
+    data_files="$data_files data-$i"
+done
+
+info Checking armored signatures
+for i in $plain_files $data_files ; do
+    echo "$usrpass1" | run_g10 --passphrase-fd 0 -sa -o x --yes $i || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+info Checking signatures
+for i in $plain_files $data_files; do
+    echo "$usrpass1" | run_g10 --passphrase-fd 0 -s -o x --yes $i  || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+
+info Checking armored encryption
+for i in $plain_files $data_files ; do
+    run_g10 -ea -o x --yes -r "$usrname2" $i  || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+info Checking armored encryption with a pipe
+for i in $plain_files $data_files ; do
+    run_g10 -ea --yes -r "$usrname2" < $i | tee x \
+    | run_g10 -o y --yes || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+    run_g10 --yes < x > y || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+info Checking encryption
+for i in $plain_files $data_files ; do
+    run_g10 -e -o x --yes -r "$usrname2" $i   || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+info Checking encryption with a pipe
+for i in $plain_files $data_files ; do
+    run_g10 -e --yes -r "$usrname2" < $i \
+    | run_g10 --yes > y || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+
+info Checking signing and encryption
+for i in $plain_files $data_files ; do
+    echo "$usrpass1" \
+    | run_g10 --passphrase-fd 0 -se -o x --yes -r "$usrname2" $i
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+info Checking armored signing and encryption
+for i in $plain_files $data_files ; do
+    echo "$usrpass1" \
+    | run_g10 --passphrase-fd 0 -sae -o x --yes -r "$usrname2" $i || error "g10 failed: $?"
+    run_g10 -o y --yes x || error "g10 failed: $?"
+    cmp $i y || error "$i: mismatch"
+done
+
+
+info Checking armored detached signatures
+for i in $plain_files $data_files ; do
+    echo "$usrpass1" | run_g10 --passphrase-fd 0 -sab -o x --yes $i || error "g10 failed: $?"
+    run_g10 -o /dev/null --yes x  <$i || error "$i: bad signature"
+done
+
+info Checking detached signatures
+for i in $plain_files $data_files ; do
+    echo "$usrpass1" | run_g10 --passphrase-fd 0 -sb -o x --yes $i  || error "g10 failed: $?"
+    run_g10 -o /dev/null --yes x  <$i || error "$i: bad signature"
+done
+
+
+info Checking detached signatures of multiple files
+i="$plain_files $data_files"
+echo "$usrpass1" | run_g10 --passphrase-fd 0 -sb -o x --yes $i  || error "g10 failed: $?"
+cat $i | run_g10 -o /dev/null --yes x || error "$i: bad signature"
+
+info Checking armored detached signatures of multiple files
+i="$plain_files $data_files"
+echo "$usrpass1" | run_g10 --passphrase-fd 0 -sab -o x --yes $i || error "g10 failed: $?"
+cat $i | run_g10 -o /dev/null --yes x || error "$i: bad signature"
+
+rm $data_files x y z
+
+info "All tests passed."
+exit 0
+
diff -urN g10-0.2.3/checks/distfiles g10-0.2.4/checks/distfiles
--- g10-0.2.3/checks/distfiles	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/checks/distfiles	Wed Feb 11 16:36:55 1998
@@ -0,0 +1 @@
+checkit plain-1 plain-2 plain-3
diff -urN g10-0.2.3/checks/plain-1 g10-0.2.4/checks/plain-1
--- g10-0.2.3/checks/plain-1	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/checks/plain-1	Wed Feb 11 15:33:33 1998
@@ -0,0 +1,23 @@
+<!-- Dies ist Seite 3, dort ist keine Seitenzahl angegeben,
+     oben rechts ist wieder der Stempel von meinem Opa zu finden -->
+
+<sect1>Name <q>Gro-Bartloff</>
+
+<p>
+Der Name <q/Bartloff/ ist schwer zu deuten. Man hat viele Mutmaungen
+angestellt, von denen man aber bislang keine einzige als unbedingt
+richtig erklren kann.
+<fontinfo rem="mit Leerzeichen geschrieben">Urkundlich</> wird das
+Dorf bis zur Reformation stets <q/Bartorf/ (anno 1253) und
+<q/Bardorf/ (1306, 1318, 1329, 1429) genannt und das_ sowohl Klein-
+wie Grobartloff. Erst 1586 im Bischofssteiner Jurisdiktionalbuch
+heit unser Dorf <q/Bartteloff/ und so auch in der ltesten noch
+vorhandenen Kirchenrechnung vom Jahre 1651. NAch dem Jahre 1700 wird
+in den Urkunden begonnen, den vollen Namen <q/Gro-Bartloff/ und
+<q/Klein-Bartloff/ zu schreiben.
+---------------- [wegen dashed escaped text]
+<p>
+Nimmt man an, da die urkundliche, lteste Bezeichnung Bartorf die
+ursprngliche ist und nicht die mundartliche Bartloff, so knnte der
+Name gut gedeutet werden als Dorf an der <q/Borde/ oder am Rande
+oder an der Grenze entweder des Waldes
diff -urN g10-0.2.3/checks/plain-2 g10-0.2.4/checks/plain-2
--- g10-0.2.3/checks/plain-2	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/checks/plain-2	Wed Feb 11 15:31:53 1998
@@ -0,0 +1,49 @@
+
+
+<sect>Vorwort
+<p>
+Der Wert einer Ortschronik ist offenbar und bedarf keiner Errterung.
+Mit Ausbruch des Weltkrieges_, inmitten der gewaltigen Geschehnisse, fhlte
+der Klerus_ unseres_ Eichs_feldes_ das_ mehr wie frher und so
+erstarkte das_ Streben, eine solche Orts_geschichte zu scahffen, um
+unseren Nachkommen zu berichten, was_ auch die kleinsten Drfer in
+der groen Zeit geleistet, erlebt und erlitten haben.
+<p>
+Und so begann auch ich im Dezember 1914, den ?????????
+Stoff, wo immer ich ihn auch nur so sprlich finden konnte, zu
+sammeln, ich befragte zunchst emsig die ltesten Leute,
+durchforschte sodann das ganze Pfarrarchiv, das Schulzenarchiv
+beider Pfarrdrfer, das Kommissariats_archiv zu Heiligenstadt,
+endlich auch 1916 das Staats_archiv zu Magdeburg. Selbstverstndlich
+arbeitete ich auch die einschlgige Literatur durch. Gar viele Zeit
+und Mhe hat es_ gekostet um nach mehr als 8 Jahren die Ortschronik von
+Grobartloff und vom Filialdorf Wilbich gesondert zu schaffen.
+<p vspace="2ex">
+<bf>Grobartloff,</> den 23. Mrz 1923.
+<p vspace="3ex" align=right>
+<bf/Nikolaus Gring,/ Pfarrer.
+</p>
+
+<!-- Hier folgt ein Stempel von meinem Opa:
+	  Rud. Koch
+     Grobartloff/Eichsfeld
+	Anger 161
+-->
+<!-- FIXME: hier kommt einen Zierlinie -->
+
+<p vspace=fill> <!-- Der Rest kam am Ende der Seite -->
+<p align=center> Literatur: </p>
+1) Joh. Wolf: Politische Geschichte des Eichsf. Gtt. 1792 und
+Lffler 1921. 2) K. Geschichte, Wolf 1816 Gtt.  3) Knieb: Gesch.
+der Ref. u. Gegenref???
+
+<!-- FIXME: Der Rest fehlt noch -->
+
+
+
+
+
+
+
+
+</sect>
diff -urN g10-0.2.3/checks/plain-3 g10-0.2.4/checks/plain-3
--- g10-0.2.3/checks/plain-3	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/checks/plain-3	Wed Feb 11 15:42:51 1998
@@ -0,0 +1 @@
+Dies ist eine einfache Zeile ohne LF am Ende.
\ No newline at end of file
diff -urN g10-0.2.3/cipher/ChangeLog g10-0.2.4/cipher/ChangeLog
--- g10-0.2.3/cipher/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/cipher/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/cipher/Makefile.in g10-0.2.4/cipher/Makefile.in
--- g10-0.2.3/cipher/Makefile.in	Mon Feb  9 18:04:38 1998
+++ g10-0.2.4/cipher/Makefile.in	Wed Feb 11 23:20:05 1998
@@ -130,7 +130,7 @@
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
@@ -243,8 +243,9 @@
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
 	../include/../cipher/gost.h ../include/../cipher/elgamal.h
-md5.o: md5.c ../include/util.h ../include/types.h ../include/errors.h \
-	../include/mpi.h ../include/iobuf.h ../include/memory.h md5.h
+md5.o md5.lo: md5.c ../config.h ../include/util.h ../include/types.h \
+	../include/errors.h ../include/mpi.h ../include/iobuf.h \
+	../include/memory.h md5.h
 misc.o: misc.c ../include/util.h ../include/types.h ../include/errors.h \
 	../include/mpi.h ../include/iobuf.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
diff -urN g10-0.2.3/cipher/blowfish.c g10-0.2.4/cipher/blowfish.c
--- g10-0.2.3/cipher/blowfish.c	Tue Feb  3 09:21:56 1998
+++ g10-0.2.4/cipher/blowfish.c	Tue Feb 10 15:49:03 1998
@@ -228,7 +228,7 @@
 
 
 
-static u32
+static inline u32
 function_F( BLOWFISH_context *bc, u32 x )
 {
     u16 a, b, c, d;
diff -urN g10-0.2.3/cipher/elgamal.c g10-0.2.4/cipher/elgamal.c
--- g10-0.2.3/cipher/elgamal.c	Mon Feb  9 14:41:38 1998
+++ g10-0.2.4/cipher/elgamal.c	Wed Feb 11 13:33:49 1998
@@ -311,17 +311,17 @@
     int rc;
     MPI t1;
     MPI t2;
+    MPI base[4];
+    MPI exp[4];
 
     if( !(mpi_cmp_ui( a, 0 ) > 0 && mpi_cmp( a, pkey->p ) < 0) )
 	return 0; /* assertion	0 < a < p  failed */
 
     t1 = mpi_alloc( mpi_get_nlimbs(a) );
     t2 = mpi_alloc( mpi_get_nlimbs(a) );
-    /* t1 = (y^a mod p) * (a^b mod p) mod p
-     * fixme: should be calculated by a call which evalutes
-     *	  t1 = y^a * a^b mod p
-     * direct.
-     */
+
+  #if 0
+    /* t1 = (y^a mod p) * (a^b mod p) mod p */
     mpi_powm( t1, pkey->y, a, pkey->p );
     mpi_powm( t2, a, b, pkey->p );
     mpi_mulm( t1, t1, t2, pkey->p );
@@ -330,6 +330,28 @@
     mpi_powm( t2, pkey->g, input, pkey->p );
 
     rc = !mpi_cmp( t1, t2 );
+  #elif 0
+    /* t1 = (y^a mod p) * (a^b mod p) mod p */
+    base[0] = pkey->y; exp[0] = a;
+    base[1] = a;       exp[1] = b;
+    base[2] = NULL;    exp[2] = NULL;
+    mpi_mulpowm( t1, base, exp, pkey->p );
+
+    /* t2 = g ^ input mod p */
+    mpi_powm( t2, pkey->g, input, pkey->p );
+
+    rc = !mpi_cmp( t1, t2 );
+  #else
+    /* t1 = g ^ - input * y ^ a * a ^ b  mod p */
+    mpi_invm(t2, pkey->g, pkey->p );
+    base[0] = t2     ; exp[0] = input;
+    base[1] = pkey->y; exp[1] = a;
+    base[2] = a;       exp[2] = b;
+    base[3] = NULL;    exp[3] = NULL;
+    mpi_mulpowm( t1, base, exp, pkey->p );
+    rc = !mpi_cmp_ui( t1, 1 );
+
+  #endif
 
     mpi_free(t1);
     mpi_free(t2);
diff -urN g10-0.2.3/cipher/md.c g10-0.2.4/cipher/md.c
--- g10-0.2.3/cipher/md.c	Mon Feb  9 17:41:45 1998
+++ g10-0.2.4/cipher/md.c	Wed Feb 11 22:52:15 1998
@@ -28,7 +28,7 @@
 #include "errors.h"
 
 
-static FILE *dumpfp;
+/*static FILE *dumpfp;*/
 
 /****************
  * Open a message digest handle for use with algorithm ALGO.
@@ -40,14 +40,16 @@
 {
     MD_HANDLE hd;
 
+   #if 0
     if( !dumpfp )
 	dumpfp = fopen("md.out", "w");
     if( !dumpfp )
 	BUG();
     { int i; for(i=0; i < 16; i++ ) putc('\xff', dumpfp ); }
-
+   #endif
     hd = secure ? m_alloc_secure_clear( sizeof *hd )
 		: m_alloc_clear( sizeof *hd );
+    hd->secure = secure;
     if( algo )
 	md_enable( hd, algo );
     return hd;
@@ -78,9 +80,9 @@
 {
     MD_HANDLE b;
 
-    { int i; for(i=0; i < 16; i++ ) putc('\xee', dumpfp ); }
-    b = m_is_secure(a)? m_alloc_secure( sizeof *b )
-		      : m_alloc( sizeof *b );
+    /*{ int i; for(i=0; i < 16; i++ ) putc('\xee', dumpfp ); }*/
+    b = a->secure ? m_alloc_secure( sizeof *b )
+		  : m_alloc( sizeof *b );
     memcpy( b, a, sizeof *a );
     return b;
 }
@@ -98,10 +100,10 @@
 void
 md_write( MD_HANDLE a, byte *inbuf, size_t inlen)
 {
-    if( a->bufcount && fwrite(a->buffer, a->bufcount, 1, dumpfp ) != 1 )
+  /*  if( a->bufcount && fwrite(a->buffer, a->bufcount, 1, dumpfp ) != 1 )
 	BUG();
     if( inlen && fwrite(inbuf, inlen, 1, dumpfp ) != 1 )
-	BUG();
+	BUG(); */
     if( a->use_rmd160 ) {
 	rmd160_write( &a->rmd160, a->buffer, a->bufcount );
 	rmd160_write( &a->rmd160, inbuf, inlen	);
@@ -124,7 +126,7 @@
 {
     if( a->bufcount )
 	md_write( a, NULL, 0 );
-    { int i; for(i=0; i < 16; i++ ) putc('\xcc', dumpfp ); }
+    /*{ int i; for(i=0; i < 16; i++ ) putc('\xcc', dumpfp ); }*/
     if( a->use_rmd160 ) {
 	byte *p;
 	rmd160_final( &a->rmd160 );
diff -urN g10-0.2.3/cipher/md.h g10-0.2.4/cipher/md.h
--- g10-0.2.3/cipher/md.h	Fri Jan  9 13:31:57 1998
+++ g10-0.2.4/cipher/md.h	Wed Feb 11 16:02:21 1998
@@ -36,6 +36,7 @@
     MD5_CONTEXT md5;
     byte buffer[MD_BUFFER_SIZE]; /* primary buffer */
     int  bufcount;
+    int  secure;
 } *MD_HANDLE;
 
 
@@ -55,6 +56,6 @@
 void md_final(MD_HANDLE a);
 byte *md_read( MD_HANDLE a, int algo );
 int md_get_algo( MD_HANDLE a );
-
+#define md_is_secure(a) ((a)->secure)
 
 #endif /*G10_MD_H*/
diff -urN g10-0.2.3/cipher/md5.c g10-0.2.4/cipher/md5.c
--- g10-0.2.3/cipher/md5.c	Fri Jan 16 12:16:48 1998
+++ g10-0.2.4/cipher/md5.c	Tue Feb 10 15:54:36 1998
@@ -93,7 +93,18 @@
 #define I(x, y, z) ((y) ^ ((x) | (~z)))
 
 /* ROTATE_LEFT rotates x left n bits */
-#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
+#if defined(__GNUC__) && defined(__i386__)
+static inline u32
+ROTATE_LEFT(u32 x, int n)
+{
+	__asm__("roll %%cl,%0"
+		:"=r" (x)
+		:"0" (x),"c" (n));
+	return x;
+}
+#else
+  #define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
+#endif
 
 /* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4 */
 /* Rotation is separate from addition to prevent recomputation */
diff -urN g10-0.2.3/cipher/rmd160.c g10-0.2.4/cipher/rmd160.c
--- g10-0.2.3/cipher/rmd160.c	Tue Feb  3 09:21:56 1998
+++ g10-0.2.4/cipher/rmd160.c	Tue Feb 10 15:50:21 1998
@@ -151,6 +151,20 @@
 }
 
 
+#if defined(__GNUC__) && defined(__i386__)
+static inline u32
+rol(int n, u32 x)
+{
+	__asm__("roll %%cl,%0"
+		:"=r" (x)
+		:"0" (x),"c" (n));
+	return x;
+}
+#else
+  #define rol(n,x) ( ((x) << (n)) | ((x) >> (32-(n))) )
+#endif
+
+
 /****************
  * Transform the message X which consists of 16 32-bit-words
  */
@@ -208,9 +222,6 @@
 		      (a) < 48 ? F2((x),(y),(z)) : \
 		      (a) < 64 ? F3((x),(y),(z)) : \
 				 F4((x),(y),(z)) )
-
-#define rol(n,x) ( ((x) << (n)) | ((x) >> (32-(n))) )
-
 
   #ifdef BIG_ENDIAN_HOST
     { int i;
diff -urN g10-0.2.3/cipher/sha1.c g10-0.2.4/cipher/sha1.c
--- g10-0.2.3/cipher/sha1.c	Tue Feb  3 09:21:57 1998
+++ g10-0.2.4/cipher/sha1.c	Tue Feb 10 15:51:52 1998
@@ -99,14 +99,30 @@
 #define K3  0x8F1BBCDCL 				/* Rounds 40-59 */
 #define K4  0xCA62C1D6L 				/* Rounds 60-79 */
 
-#define ROTL(n,X)  ( ( ( X ) << n ) | ( ( X ) >> ( 32 - n ) ) )
+
+#if defined(__GNUC__) && defined(__i386__)
+static inline u32
+rol(int n, u32 x)
+{
+	__asm__("roll %%cl,%0"
+		:"=r" (x)
+		:"0" (x),"c" (n));
+	return x;
+}
+#else
+  #define rol(n,x)  ( ((x) << (n)) | ((x) >> (32-(n))) )
+#endif
+
+
+
+
 
 #define expand(W,i) ( W[ i & 15 ] = \
-		     ROTL( 1, ( W[ i & 15 ] ^ W[ (i - 14) & 15 ] ^ \
+		     rol( 1, ( W[ i & 15 ] ^ W[ (i - 14) & 15 ] ^ \
 				W[ (i - 8) & 15 ] ^ W[ (i - 3) & 15 ] ) ) )
 
 #define subRound(a, b, c, d, e, f, k, data) \
-    ( e += ROTL( 5, a ) + f( b, c, d ) + k + data, b = ROTL( 30, b ) )
+    ( e += rol( 5, a ) + f( b, c, d ) + k + data, b = rol( 30, b ) )
 
 
 void
diff -urN g10-0.2.3/g10/ChangeLog g10-0.2.4/g10/ChangeLog
--- g10-0.2.3/g10/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/g10/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/g10/Makefile.in g10-0.2.4/g10/Makefile.in
--- g10-0.2.3/g10/Makefile.in	Mon Feb  9 18:04:46 1998
+++ g10-0.2.4/g10/Makefile.in	Wed Feb 11 23:20:22 1998
@@ -174,7 +174,7 @@
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
@@ -393,13 +393,14 @@
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h ../include/errors.h \
 	keydb.h ../include/util.h trustdb.h
-kbnode.o: kbnode.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md5.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/blowfish.h \
-	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
-	filter.h keydb.h
+kbnode.o kbnode.lo: kbnode.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/rsa.h \
+	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
+	../include/../cipher/elgamal.h filter.h keydb.h
 keygen.o keygen.lo: keygen.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h main.h \
@@ -457,15 +458,15 @@
 	../include/../cipher/md5.h ../include/../cipher/rsa.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h keydb.h packet.h filter.h
-pkclist.o: pkclist.c options.h packet.h ../include/types.h \
-	../include/iobuf.h ../include/mpi.h ../include/memory.h \
-	../include/cipher.h ../include/../cipher/md.h \
-	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
-	../include/../cipher/md5.h ../include/../cipher/rsa.h \
-	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
-	../include/../cipher/elgamal.h filter.h ../include/errors.h \
-	keydb.h ../include/util.h trustdb.h ../include/ttyio.h \
-	../include/i18n.h
+pkclist.o pkclist.lo: pkclist.c ../config.h options.h packet.h \
+	../include/types.h ../include/iobuf.h ../include/mpi.h \
+	../include/memory.h ../include/cipher.h \
+	../include/../cipher/md.h ../include/../cipher/rmd.h \
+	../include/../cipher/sha1.h ../include/../cipher/md5.h \
+	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
+	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
+	filter.h ../include/errors.h keydb.h ../include/util.h \
+	trustdb.h ../include/ttyio.h ../include/i18n.h
 plaintext.o plaintext.lo: plaintext.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h options.h packet.h \
@@ -505,22 +506,22 @@
 	../include/../cipher/md5.h ../include/../cipher/rsa.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h filter.h keydb.h
-seskey.o: seskey.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h ../include/cipher.h \
+seskey.o seskey.lo: seskey.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h ../include/cipher.h \
 	../include/../cipher/md.h ../include/../cipher/rmd.h \
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
 	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
 	main.h keydb.h packet.h filter.h
-sig-check.o: sig-check.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h packet.h ../include/cipher.h \
-	../include/../cipher/md.h ../include/../cipher/rmd.h \
-	../include/../cipher/sha1.h ../include/../cipher/md5.h \
-	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
-	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
-	filter.h keydb.h main.h
+sig-check.o sig-check.lo: sig-check.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h packet.h \
+	../include/cipher.h ../include/../cipher/md.h \
+	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
+	../include/../cipher/md5.h ../include/../cipher/rsa.h \
+	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
+	../include/../cipher/elgamal.h filter.h keydb.h main.h
 sign.o sign.lo: sign.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
diff -urN g10-0.2.3/g10/OPTIONS g10-0.2.4/g10/OPTIONS
--- g10-0.2.3/g10/OPTIONS	Fri Jan 30 16:39:00 1998
+++ g10-0.2.4/g10/OPTIONS	Wed Feb 11 13:57:44 1998
@@ -154,7 +154,10 @@
 
 
 keyring  filename
-# add this filename to the list of keyrings
+# add this filename to the list of keyrings.
+# If the filename begins with a tilde and a slash, these are replaced
+# by the HOME directory. If the filename does not contain a slash, it
+# is assumed to be in "~/.g10"
 
 local-user user-string
 #  use this user-string to sign or decrypt
@@ -191,6 +194,7 @@
 
 secret-keyring filename
 # add filename to the list of secret keyrings
+# see "keyring" for further informations
 
 status-fd n
 # Write status informations to this file descriptor. If this option
diff -urN g10-0.2.3/g10/armor.c g10-0.2.4/g10/armor.c
--- g10-0.2.3/g10/armor.c	Mon Feb  9 14:16:53 1998
+++ g10-0.2.4/g10/armor.c	Wed Feb 11 23:11:11 1998
@@ -288,9 +288,11 @@
 	    if( n < buflen || c == '\n' ) {
 		if( n && buf[0] != '\r') { /* maybe a header */
 		    if( strchr( buf, ':') ) { /* yes */
-			log_debug("armor header: ");
-			print_string( stderr, buf, n );
-			putc('\n', stderr);
+			if( opt.verbose ) {
+			    log_info("armor header: ");
+			    print_string( stderr, buf, n );
+			    putc('\n', stderr);
+			}
 			if( clearsig && !parse_hash_header( buf ) ) {
 			    log_error("invalid clearsig header\n");
 			    state = fhdrERROR;
@@ -321,9 +323,11 @@
 	    }
 	    else if( c != -1 ) {
 		if( strchr( buf, ':') ) { /* buffer to short, but this is okay*/
-		    log_debug("armor header: ");
-		    print_string( stderr, buf, n );
-		    fputs("[...]\n", stderr);  /* indicate it is truncated */
+		    if( opt.verbose ) {
+			log_info("armor header: ");
+			print_string( stderr, buf, n );
+			fputs("[...]\n", stderr);  /* indicate it is truncated */
+		    }
 		    state = fhdrSKIPHeader;  /* skip rest of line */
 		}
 		else /* line too long */
@@ -380,7 +384,8 @@
 	    state = fhdrWAITHeader;
 	    if( hdr_line == BEGIN_SIGNED_MSG_IDX )
 		clearsig = 1;
-	    log_debug("armor: %s\n", head_strings[hdr_line]);
+	    if( opt.verbose > 1 )
+		log_info("armor: %s\n", head_strings[hdr_line]);
 	    break;
 
 	  case fhdrCLEARSIG:
@@ -432,15 +437,24 @@
 	    break;
 
 	  case fhdrCHECKClearsig:
-	  case fhdrCHECKClearsig2:
 	    /* check the clearsig line */
 	    if( n > 15 && !memcmp(buf, "-----", 5 ) )
 		state = fhdrENDClearsig;
 	    else if( buf[0] == '-' && buf[1] == ' ' )
 		state = fhdrCHECKDashEscaped;
 	    else {
-		state = state == fhdrCHECKClearsig2 ?
-				  fhdrREADClearsig : fhdrTESTSpaces;
+		state = fhdrTESTSpaces;
+	    }
+	    break;
+
+	  case fhdrCHECKClearsig2:
+	    /* check the clearsig line */
+	    if( n > 15 && !memcmp(buf, "-----", 5 ) )
+		state = fhdrENDClearsig;
+	    else if( buf[0] == '-' && buf[1] == ' ' )
+		state = fhdrCHECKDashEscaped2;
+	    else {
+		state = fhdrREADClearsig;
 	    }
 	    break;
 
@@ -812,7 +826,7 @@
     int  idx, idx2;
     size_t n=0;
     u32 crc;
-  #if 1
+  #if 0
     static FILE *fp ;
 
     if( !fp ) {
@@ -884,7 +898,7 @@
 	}
 	else
 	    rc = radix64_read( afx, a, &n, buf, size );
-      #if 1
+      #if 0
 	if( n )
 	    if( fwrite(buf, n, 1, fp ) != 1 )
 		BUG();
diff -urN g10-0.2.3/g10/g10.c g10-0.2.4/g10/g10.c
--- g10-0.2.3/g10/g10.c	Mon Feb  9 13:13:26 1998
+++ g10-0.2.4/g10/g10.c	Wed Feb 11 20:09:53 1998
@@ -215,6 +215,7 @@
     { 537, "export", 0, N_("export all or the given keys") },
     { 538, "trustdb-name", 2, "\r" },
     { 539, "clearsign", 0, N_("make a clear text signature") },
+    { 540, "no-secmem-warning", 0, "\r" }, /* used only by regression tests */
 
     {0} };
     ARGPARSE_ARGS pargs;
@@ -231,7 +232,7 @@
     FILE *configfp = NULL;
     char *configname = NULL;
     unsigned configlineno;
-    int parse_verbose = 0;
+    int parse_debug = 0;
     int default_config =1;
     int errors=0;
     int default_keyring = 1;
@@ -259,8 +260,8 @@
     pargs.argv = &argv;
     pargs.flags=  1;  /* do not remove the args */
     while( arg_parse( &pargs, opts) ) {
-	if( pargs.r_opt == 'v' )
-	    parse_verbose++;
+	if( pargs.r_opt == 510 || pargs.r_opt == 511 )
+	    parse_debug++;
 	else if( pargs.r_opt == 518 ) {
 	    /* yes there is one, so we do not try the default one, but
 	     * read the option file when it is encountered at the commandline
@@ -283,7 +284,7 @@
 	configfp = fopen( configname, "r" );
 	if( !configfp ) {
 	    if( default_config ) {
-		if( parse_verbose > 1 )
+		if( parse_debug )
 		log_info(_("note: no default option file '%s'\n"), configname );
 	    }
 	    else
@@ -291,7 +292,7 @@
 				    configname, strerror(errno) );
 	    m_free(configname); configname = NULL;
 	}
-	if( parse_verbose > 1 )
+	if( parse_debug && configname )
 	    log_info(_("reading options from '%s'\n"), configname );
 	default_config = 0;
     }
@@ -370,6 +371,7 @@
 	  case 537: set_cmd( &cmd, aExport); break;
 	  case 538: trustdb_name = pargs.r.ret_str; break;
 	  case 539: set_cmd( &cmd, aClearsign); break;
+	  case 540: secmem_set_flags( secmem_get_flags() | 1 ); break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
@@ -403,6 +405,13 @@
     if( errors )
 	g10_exit(2);
 
+    if( greeting ) {
+	if( *(s=strusage(10))  )
+	    tty_printf("%s", s);
+	if( *(s=strusage(30))  )
+	    tty_printf("%s", s);
+    }
+
     /* initialize the secure memory. */
     secmem_init( 16384 );
     /* Okay, we are now working under our real uid */
@@ -425,23 +434,11 @@
     }
     if( opt.verbose > 1 )
 	set_packet_list_mode(1);
-    if( greeting ) {
-	if( *(s=strusage(10))  )
-	    tty_printf("%s", s);
-	if( *(s=strusage(30))  )
-	    tty_printf("%s", s);
-    }
 
-    if( !sec_nrings || default_keyring ) { /* add default secret rings */
-	char *p = make_filename("~/.g10", "secring.g10", NULL );
-	add_secret_keyring(p);
-	m_free(p);
-    }
-    if( !nrings || default_keyring ) { /* add default ring */
-	char *p = make_filename("~/.g10", "pubring.g10", NULL );
-	add_keyring(p);
-	m_free(p);
-    }
+    if( !sec_nrings || default_keyring )  /* add default secret rings */
+	add_secret_keyring("secring.g10");
+    if( !nrings || default_keyring )  /* add default ring */
+	add_keyring("pubring.g10");
 
     if( argc ) {
 	fname_print = fname = *argv;
@@ -640,7 +637,7 @@
 void
 g10_exit( int rc )
 {
-    if( opt.verbose )
+    if( opt.debug )
 	secmem_dump_stats();
     secmem_term();
     rc = rc? rc : log_get_errorcount(0)? 2:0;
diff -urN g10-0.2.3/g10/g10maint.c g10-0.2.4/g10/g10maint.c
--- g10-0.2.3/g10/g10maint.c	Mon Feb  9 14:52:32 1998
+++ g10-0.2.4/g10/g10maint.c	Wed Feb 11 02:17:57 1998
@@ -478,7 +478,7 @@
 	}
 	break;
 
-      case aTest: do_test( argc? atoi(*argv): 0 ); break;
+      case aTest: do_test( argc? atoi(*argv): 1 ); break;
 
       case aListTrustDB:
 	if( !argc )
@@ -603,27 +603,41 @@
 static void
 do_test(int times)
 {
-  #if 0
-    MPI t = mpi_alloc( 50 );
-    MPI m = mpi_alloc( 50 );
-    MPI a = mpi_alloc( 50 );
-    MPI b = mpi_alloc( 50 );
-    MPI p = mpi_alloc( 50 );
-    MPI x = mpi_alloc( 50 );
-
-    /* output = b/(a^x) mod p */
-    log_debug("invm %d times ", times);
-    for( ; times > 0; times -- ) {
-	mpi_fromstr(a, "0xef45678343589854354a4545545454554545455"
-		       "aaaaaaaaaaaaa44444fffdecb33434343443331" );
-	mpi_fromstr(b, "0x8765765589854354a4545545454554545455"
-		       "aaaaaaa466577778decb36666343443331" );
-	mpi_invm( t, a, b );
-	fputc('.', stderr); fflush(stderr);
-    }
+    MPI base[4];
+    MPI exp[4];
+    MPI t1 = mpi_alloc(50);
+    MPI t2 = mpi_alloc(50);
+    MPI t3 = mpi_alloc(50);
+    MPI tmp= mpi_alloc(50);
+    MPI m =   mpi_alloc(50);
+    MPI res = mpi_alloc(50);
+
+    mpi_fromstr( m, "0x10000000000000000000000000" );
+    base[0] = mpi_alloc_set_ui( 3 );
+    mpi_fromstr( base[0], "0x145984358945989898495ffdd13" );
+    base[1] = mpi_alloc_set_ui( 5 );
+    mpi_fromstr( base[1], "0x000effff9999000000001100001" );
+    base[2] = mpi_alloc_set_ui( 2 );
+    mpi_fromstr( base[2], "0x499eeeaaaaa0444444545466672" );
+    base[3] = NULL;
+    exp[0]  = mpi_alloc_set_ui( 30 );
+    exp[1]  = mpi_alloc_set_ui( 10 );
+    mpi_fromstr( exp[1], "0x3457878888888888aabbbccccc1" );
+    exp[2]  = mpi_alloc_set_ui( 24 );
+    exp[3] = NULL;
+
+    mpi_powm( t1, base[0], exp[0], m );
+    mpi_powm( t2, base[1], exp[1], m );
+    mpi_powm( t3, base[2], exp[2], m );
+    mpi_mulm( tmp, t1, t2, m );
+    mpi_mulm( t1, tmp, t3, m );
+    log_mpidump("X=", t1 );
+
+
+    mpi_mulpowm( res, base, exp, m );
+    log_mpidump("X=", res );
 
 
     m_check(NULL);
-  #endif
 }
 
diff -urN g10-0.2.3/g10/getkey.c g10-0.2.4/g10/getkey.c
--- g10-0.2.3/g10/getkey.c	Mon Feb  2 20:52:56 1998
+++ g10-0.2.4/g10/getkey.c	Wed Feb 11 14:01:59 1998
@@ -73,7 +73,8 @@
 static int scan_secret_keyring( PKT_secret_cert *skc, u32 *keyid,
 				const char *name, const char *filename);
 
-
+/* note this function may be called before secure memory is
+ * available */
 void
 add_keyring( const char *name )
 {
@@ -81,19 +82,32 @@
     int rc;
 
     /* FIXME: check wether this one is available etc */
-    /* my be we should do this later */
-    sl = m_alloc( sizeof *sl + strlen(name) );
-    strcpy(sl->d, name );
+    /* maybe we should do this later */
+    if( *name != '/' ) { /* do tilde expansion etc */
+	char *p ;
+
+	if( strchr(name, '/') )
+	    p = make_filename(name, NULL);
+	else
+	    p = make_filename("~/.g10", name, NULL);
+	sl = m_alloc( sizeof *sl + strlen(p) );
+	strcpy(sl->d, p );
+	m_free(p);
+    }
+    else {
+	sl = m_alloc( sizeof *sl + strlen(name) );
+	strcpy(sl->d, name );
+    }
     sl->next = keyrings;
     keyrings = sl;
 
-    /* FIXME: We should remove much out of this mpdule and
+    /* FIXME: We should remove much out of this module and
      * combine it with the keyblock stuff from ringedit.c
      * For now we will simple add the filename as keyblock resource
      */
-    rc = add_keyblock_resource( name, 0, 0 );
+    rc = add_keyblock_resource( sl->d, 0, 0 );
     if( rc )
-	log_error("keyblock resource '%s': %s\n", name, g10_errstr(rc) );
+	log_error("keyblock resource '%s': %s\n", sl->d, g10_errstr(rc) );
 }
 
 
@@ -119,8 +133,21 @@
 
     /* FIXME: check wether this one is available etc */
     /* my be we should do this later */
-    sl = m_alloc( sizeof *sl + strlen(name) );
-    strcpy(sl->d, name );
+    if( *name != '/' ) { /* do tilde expansion etc */
+	char *p ;
+
+	if( strchr(name, '/') )
+	    p = make_filename(name, NULL);
+	else
+	    p = make_filename("~/.g10", name, NULL);
+	sl = m_alloc( sizeof *sl + strlen(p) );
+	strcpy(sl->d, p );
+	m_free(p);
+    }
+    else {
+	sl = m_alloc( sizeof *sl + strlen(name) );
+	strcpy(sl->d, name );
+    }
     sl->next = secret_keyrings;
     secret_keyrings = sl;
 
@@ -128,9 +155,9 @@
      * combine it with the keyblock stuff from ringedit.c
      * For now we will simple add the filename as keyblock resource
      */
-    rc = add_keyblock_resource( name, 0, 1 );
+    rc = add_keyblock_resource( sl->d, 0, 1 );
     if( rc )
-	log_error("secret keyblock resource '%s': %s\n", name, g10_errstr(rc) );
+	log_error("secret keyblock resource '%s': %s\n", sl->d, g10_errstr(rc));
 }
 
 
diff -urN g10-0.2.3/g10/kbnode.c g10-0.2.4/g10/kbnode.c
--- g10-0.2.3/g10/kbnode.c	Fri Jan  2 21:17:18 1998
+++ g10-0.2.4/g10/kbnode.c	Wed Feb 11 13:44:01 1998
@@ -36,7 +36,6 @@
     KBNODE n = m_alloc( sizeof *n );
     n->next = NULL;
     n->pkt = pkt;
-    n->child = NULL;
     n->flag = 0;
     n->private_flag=0; /* kludge to delete a node */
     return n;
@@ -50,7 +49,6 @@
 
     while( n ) {
 	n2 = n->next;
-	release_kbnode( n->child );
 	free_packet( n->pkt );
 	m_free( n );
 	n = n2;
@@ -60,7 +58,7 @@
 
 /****************
  * Delete NODE from ROOT, ROOT must exist!
- * Note does only work with walk_kbtree!!
+ * Note: This does only work with walk_kbnode!!
  */
 void
 delete_kbnode( KBNODE root, KBNODE node )
@@ -82,56 +80,97 @@
 }
 
 /****************
- * Append NODE to ROOT as child of ROOT
+ * Insert NODE into the list after root but before a packet with type PKTTYPE
+ * (only if PKTTYPE != 0)
  */
 void
-add_kbnode_as_child( KBNODE root, KBNODE node )
+insert_kbnode( KBNODE root, KBNODE node, int pkttype )
 {
-    KBNODE n1;
-
-    if( !(n1=root->child) )
-	root->child = node;
+    if( !pkttype ) {
+	node->next = root->next;
+	root->next = node;
+    }
     else {
-	for( ; n1->next; n1 = n1->next)
-	    ;
+	KBNODE n1;
+
+	for(n1=root; n1->next;	n1 = n1->next)
+	    if( pkttype == n1->next->pkt->pkttype ) {
+		node->next = n1->next;
+		n1->next = node;
+		return;
+	    }
+	/* no such packet, append */
+	node->next = NULL;
 	n1->next = node;
     }
 }
 
+
 /****************
- * Return the parent node of KBNODE from the tree with ROOT
+ * Find the previous node (if PKTTYPE = 0) or the previous node
+ * with pkttype PKTTYPE in the list starting with ROOT of NODE.
  */
 KBNODE
-find_kbparent( KBNODE root, KBNODE node )
+find_prev_kbnode( KBNODE root, KBNODE node, int pkttype )
 {
-    KBNODE n, n2;
+    KBNODE n1;
 
-    for( ; root; root = root->child) {
-	for( n = root; n; n = n->next) {
-	    for( n2 = n->child; n2; n2 = n2->next ) {
-		if( n2 == node )
-		    return n;
-	    }
-	}
+    for(n1=NULL ; root && root != node; root = root->next )
+	if( !pkttype || root->pkt->pkttype == pkttype )
+	    n1 = root;
+    return n1;
+}
+
+/****************
+ * Ditto, but find the next package.  The behaviour is trivial if
+ * PKTTYPE is 0 but if it is specified, the next node with a packet
+ * of this type is returned.  The function has some knowledge about
+ * the valid ordering of packets: e.g. if the next signature packet
+ * is requested, the function will not return one if it encounters
+ * a user-id.
+ */
+KBNODE
+find_next_kbnode( KBNODE node, int pkttype )
+{
+    for( node=node->next ; node; node = node->next ) {
+	if( !pkttype )
+	    return node;
+	else if( pkttype == PKT_USER_ID
+		 && (	node->pkt->pkttype == PKT_PUBLIC_CERT
+		     || node->pkt->pkttype == PKT_SECRET_CERT ) )
+	    return NULL;
+	else if( pkttype == PKT_SIGNATURE
+		 && (	node->pkt->pkttype == PKT_USER_ID
+		     || node->pkt->pkttype == PKT_PUBLIC_CERT
+		     || node->pkt->pkttype == PKT_SECRET_CERT ) )
+	    return NULL;
+	else if( node->pkt->pkttype == pkttype )
+	    return node;
     }
     return NULL;
 }
 
 
+KBNODE
+find_kbnode( KBNODE node, int pkttype )
+{
+    for( ; node; node = node->next ) {
+	if( node->pkt->pkttype == pkttype )
+	    return node;
+    }
+    return NULL;
+}
+
+
+
 /****************
- * Walk through a tree of kbnodes. This functions returns
+ * Walk through a list of kbnodes. This functions returns
  * the next kbnode for each call; before using the function the first
  * time, the caller must set CONTEXT to NULL (This has simply the effect
  * to start with ROOT).
  */
 KBNODE
-walk_kbtree( KBNODE root, KBNODE *context )
-{
-    return walk_kbtree2( root, context, 0 );
-}
-
-KBNODE
-walk_kbtree2( KBNODE root, KBNODE *context, int all )
+walk_kbnode( KBNODE root, KBNODE *context, int all )
 {
     KBNODE n;
 
@@ -141,19 +180,8 @@
 	    return root;
 	}
 
-	n = *context;
-	if( n->child ) {
-	    n = n->child;
-	    *context = n;
-	}
-	else if( n->next ) {
-	    n = n->next;
-	    *context = n;
-	}
-	else if( (n = find_kbparent( root, n )) ) {
-	    n = n->next;
-	    *context = n;
-	}
+	n = (*context)->next;
+	*context = n;
     } while( !all && n && (n->private_flag & 1) );
 
     return n;
@@ -163,7 +191,6 @@
 clear_kbnode_flags( KBNODE n )
 {
     for( ; n; n = n->next ) {
-	clear_kbnode_flags( n->child );
 	n->flag = 0;
     }
 }
diff -urN g10-0.2.3/g10/keydb.h g10-0.2.4/g10/keydb.h
--- g10-0.2.3/g10/keydb.h	Wed Jan 14 16:18:14 1998
+++ g10-0.2.4/g10/keydb.h	Tue Feb 10 22:12:21 1998
@@ -37,9 +37,8 @@
 
 typedef struct kbnode_struct *KBNODE;
 struct kbnode_struct {
+    KBNODE next;
     PACKET *pkt;
-    KBNODE next;   /* used to form a link list */
-    KBNODE child;
     int flag;
     int private_flag;
 };
@@ -49,10 +48,9 @@
  * of a keyblock.
  */
 struct keyblock_pos_struct {
-    int   resno;  /* resource number */
-    ulong offset; /* position information */
-    ulong length; /* length of thge keyblock */
-    int last_block;
+    int   resno;     /* resource number */
+    ulong offset;    /* position information */
+    unsigned count;  /* length of the keyblock in packets */
 };
 typedef struct keyblock_pos_struct KBPOS;
 
@@ -130,10 +128,11 @@
 void release_kbnode( KBNODE n );
 void delete_kbnode( KBNODE root, KBNODE node );
 void add_kbnode( KBNODE root, KBNODE node );
-void add_kbnode_as_child( KBNODE root, KBNODE node );
-KBNODE find_kbparent( KBNODE root, KBNODE node );
-KBNODE walk_kbtree( KBNODE root, KBNODE *context );
-KBNODE walk_kbtree2( KBNODE root, KBNODE *context, int all );
+void insert_kbnode( KBNODE root, KBNODE node, int pkttype );
+KBNODE find_prev_kbnode( KBNODE root, KBNODE node, int pkttype );
+KBNODE find_next_kbnode( KBNODE node, int pkttype );
+KBNODE find_kbnode( KBNODE node, int pkttype );
+KBNODE walk_kbnode( KBNODE root, KBNODE *context, int all );
 void clear_kbnode_flags( KBNODE n );
 
 /*-- ringedit.c --*/
diff -urN g10-0.2.3/g10/keygen.c g10-0.2.4/g10/keygen.c
--- g10-0.2.3/g10/keygen.c	Mon Feb  9 14:47:11 1998
+++ g10-0.2.4/g10/keygen.c	Wed Feb 11 14:26:15 1998
@@ -102,25 +102,19 @@
     PKT_signature *sig;
     PKT_user_id *uid;
     int rc=0;
-    KBNODE kbctx, node;
+    KBNODE node;
     PKT_public_cert *pkc;
 
     if( opt.verbose )
 	log_info(_("writing self signature\n"));
 
-    /* get the uid packet from the tree */
-    for( kbctx=NULL; (node=walk_kbtree( root, &kbctx)) ; ) {
-	if( node->pkt->pkttype == PKT_USER_ID )
-	    break;
-    }
+    /* get the uid packet from the list */
+    node = find_kbnode( root, PKT_USER_ID );
     if( !node )
 	BUG(); /* no user id packet in tree */
     uid = node->pkt->pkt.user_id;
     /* get the pkc packet from the pub_tree */
-    for( kbctx=NULL; (node=walk_kbtree( pub_root, &kbctx)) ; ) {
-	if( node->pkt->pkttype == PKT_PUBLIC_CERT )
-	    break;
-    }
+    node = find_kbnode( pub_root, PKT_PUBLIC_CERT );
     if( !node )
 	BUG();
     pkc = node->pkt->pkt.public_cert;
diff -urN g10-0.2.3/g10/main.h g10-0.2.4/g10/main.h
--- g10-0.2.3/g10/main.h	Mon Feb  9 14:29:36 1998
+++ g10-0.2.4/g10/main.h	Wed Feb 11 16:38:38 1998
@@ -69,9 +69,6 @@
 /*-- seskey.c --*/
 void make_session_key( DEK *dek );
 MPI encode_session_key( DEK *dek, unsigned nbits );
-MPI encode_sha1_value( byte *md, unsigned len, unsigned nbits );
-MPI encode_rmd160_value( byte *md, unsigned len, unsigned nbits );
-MPI encode_md5_value( byte *md, unsigned len, unsigned nbits );
 MPI encode_md_value( MD_HANDLE md, unsigned nbits );
 
 /*-- comment.c --*/
diff -urN g10-0.2.3/g10/mainproc.c g10-0.2.4/g10/mainproc.c
--- g10-0.2.3/g10/mainproc.c	Wed Feb  4 11:02:04 1998
+++ g10-0.2.4/g10/mainproc.c	Wed Feb 11 16:04:54 1998
@@ -110,13 +110,13 @@
 static int
 add_user_id( CTX c, PACKET *pkt )
 {
-    KBNODE node, n1, n2;
+    KBNODE node, n1;
 
     if( !c->cert ) {
 	log_error("orphaned user id\n" );
 	return 0;
     }
-    /* goto the last certificate (currently ther is only one) */
+    /* goto the last certificate */
     for(n1=c->cert; n1->next; n1 = n1->next )
 	;
     assert( n1->pkt );
@@ -127,13 +127,7 @@
     }
     /* add a new user id node at the end */
     node = new_kbnode( pkt );
-    if( !(n2=n1->child) )
-	n1->child = node;
-    else {
-	for( ; n2->next; n2 = n2->next)
-	    ;
-	n2->next = node;
-    }
+    add_kbnode( n1, node );
     return 1;
 }
 
@@ -141,55 +135,33 @@
 static int
 add_signature( CTX c, PACKET *pkt )
 {
-    KBNODE node, n1, n2;
+    KBNODE node;
 
     if( pkt->pkttype == PKT_SIGNATURE && !c->cert ) {
 	/* This is the first signature for a following datafile.
 	 * G10 does not write such packets, instead it always uses
 	 * onepass-sig packets.  The drawback of PGP's method
-	 * of writing prepending the signtaure to the data is,
-	 * that it is not possible to make a signature from data
-	 * read from stdin.  But we are able to read these stuff. */
+	 * of prepending the signtaure to the data is,
+	 * that it is not possible to make a signature from data read
+	 * from stdin.	(Anyway, G10 is able to read these stuff) */
 	node = new_kbnode( pkt );
-	node->next = c->cert;
 	c->cert = node;
 	return 1;
     }
     else if( !c->cert )
-	return 0;
+	return 0; /* oops (invalid packet sequence)*/
     else if( !c->cert->pkt )
-	BUG();
+	BUG();	/* so nicht */
     else if( c->cert->pkt->pkttype == PKT_ONEPASS_SIG ) {
-	/* The root is a onepass signature, so we are signing data
-	 * The childs direct under the root are the signatures
-	 * (there is no need to keep the correct sequence of packets) */
+	/* The root is a onepass signature: we are signing data */
 	node = new_kbnode( pkt );
-	node->next = c->cert->child;
-	c->cert->child = node;
+	add_kbnode( c->cert, node );
 	return 1;
     }
-    else if( !c->cert->child ) {
-	log_error("orphaned signature (no userid)\n" );
-	return 0;
-    }
 
-    /* goto the last user id */
-    for(n1=c->cert->child; n1->next; n1 = n1->next )
-	;
-    assert( n1->pkt );
-    if( n1->pkt->pkttype != PKT_USER_ID ) {
-	log_error("invalid parent type %d for sig\n", n1->pkt->pkttype);
-	return 0;
-    }
-    /* and add a new signature node id at the end */
+    /* add a new signature node id at the end */
     node = new_kbnode( pkt );
-    if( !(n2=n1->child) )
-	n1->child = node;
-    else {
-	for( ; n2->next; n2 = n2->next)
-	    ;
-	n2->next = node;
-    }
+    add_kbnode( c->cert, node );
     return 1;
 }
 
@@ -333,10 +305,9 @@
     }
     else if( (sig->sig_class&~3) == 0x10 ) { /* classes 0x10 .. 0x13 */
 	if( c->cert->pkt->pkttype == PKT_PUBLIC_CERT ) {
-	    KBNODE n1 = find_kbparent( c->cert, node );
-
-	    if( n1 && n1->pkt->pkttype == PKT_USER_ID ) {
+	    KBNODE n1 = find_prev_kbnode( c->cert, node, PKT_USER_ID );
 
+	    if( n1 ) {
 		if( c->cert->pkt->pkt.public_cert->mfx.md )
 		    md = md_copy( c->cert->pkt->pkt.public_cert->mfx.md );
 		else
@@ -411,7 +382,7 @@
 static void
 list_node( CTX c, KBNODE node )
 {
-    register KBNODE n2;
+    int any=0;
 
     if( !node )
 	;
@@ -422,21 +393,19 @@
 				      pubkey_letter( pkc->pubkey_algo ),
 				      (ulong)keyid_from_pkc( pkc, NULL ),
 				      datestr_from_pkc( pkc )	  );
-	n2 = node->child;
-	if( !n2 )
-	    printf("ERROR: no user id!\n");
-	else {
-	    /* and now list all userids with their signatures */
-	    for( ; n2; n2 = n2->next ) {
-		if( n2 != node->child )
-		    printf( "%*s", 31, "" );
-		print_userid( n2->pkt );
-		putchar('\n');
-		if( opt.fingerprint && n2 == node->child )
-		    print_fingerprint( pkc, NULL );
-		list_node(c,  n2 );
-	    }
+	/* and now list all userids with their signatures */
+	while( (node = find_next_kbnode(node, PKT_USER_ID)) ) {
+	    if( any )
+		printf( "%*s", 31, "" );
+	    print_userid( node->pkt );
+	    putchar('\n');
+	    if( opt.fingerprint && !any )
+		print_fingerprint( pkc, NULL );
+	    list_node(c,  node );
+	    any=1;
 	}
+	if( !any )
+	    printf("ERROR: no user id!\n");
     }
     else if( node->pkt->pkttype == PKT_SECRET_CERT ) {
 	PKT_secret_cert *skc = node->pkt->pkt.secret_cert;
@@ -445,20 +414,21 @@
 				      pubkey_letter( skc->pubkey_algo ),
 				      (ulong)keyid_from_skc( skc, NULL ),
 				      datestr_from_skc( skc )	  );
-	n2 = node->child;
-	if( !n2 )
-	    printf("ERROR: no user id!\n");
-	else {
-	    print_userid( n2->pkt );
+	/* and now list all userids */
+	while( (node = find_next_kbnode(node, PKT_USER_ID)) ) {
+	    print_userid( node->pkt );
 	    putchar('\n');
-	    if( opt.fingerprint && n2 == node->child )
+	    if( opt.fingerprint && !any )
 		print_fingerprint( NULL, skc );
+	    any=1;
 	}
+	if( !any )
+	    printf("ERROR: no user id!\n");
     }
     else if( node->pkt->pkttype == PKT_USER_ID ) {
 	/* list everything under this user id */
-	for(n2=node->child; n2; n2 = n2->next )
-	    list_node(c,  n2 );
+	while( (node = find_next_kbnode(node, 0 )) )
+	    list_node(c, node );
     }
     else if( node->pkt->pkttype == PKT_SIGNATURE  ) {
 	PKT_signature *sig = node->pkt->pkt.signature;
@@ -467,7 +437,6 @@
 	char *p;
 	int sigrc = ' ';
 
-	assert( !node->child );
 	if( !opt.list_sigs )
 	    return;
 
@@ -626,31 +595,26 @@
     else if( node->pkt->pkttype == PKT_SECRET_CERT )
 	list_node( c, node );
     else if( node->pkt->pkttype == PKT_ONEPASS_SIG ) {
-	if( !node->child )
-	    log_error("proc_tree: onepass_sig without data\n");
-	else if( node->child->pkt->pkttype != PKT_SIGNATURE )
-	    log_error("proc_tree: onepass_sig not followed by signature\n");
-	else {	/* check all signatures */
-	    if( !c->have_data ) {
-		free_md_filter_context( &c->mfx );
-		/* prepare to create all requested message digests */
-		c->mfx.md = md_open(0, 0);
-		for(n1=node->child; n1; n1 = n1->next ) {
-		    md_enable( c->mfx.md,
-			       digest_algo_from_sig(n1->pkt->pkt.signature));
-		}
-		/* ask for file and hash it */
-		rc = ask_for_detached_datafile( &c->mfx,
-						iobuf_get_fname(c->iobuf));
-		if( rc ) {
-		    log_error("can't hash datafile: %s\n", g10_errstr(rc));
-		    return;
-		}
+	/* check all signatures */
+	if( !c->have_data ) {
+	    free_md_filter_context( &c->mfx );
+	    /* prepare to create all requested message digests */
+	    c->mfx.md = md_open(0, 0);
+	    for( n1 = node; (n1 = find_next_kbnode(n1, PKT_SIGNATURE )); ) {
+		md_enable( c->mfx.md,
+			   digest_algo_from_sig(n1->pkt->pkt.signature));
+	    }
+	    /* ask for file and hash it */
+	    rc = ask_for_detached_datafile( &c->mfx,
+					    iobuf_get_fname(c->iobuf));
+	    if( rc ) {
+		log_error("can't hash datafile: %s\n", g10_errstr(rc));
+		return;
 	    }
-
-	    for(n1=node->child; n1; n1 = n1->next )
-		check_sig_and_print( c, n1 );
 	}
+
+	for( n1 = node; (n1 = find_next_kbnode(n1, PKT_SIGNATURE )); )
+	    check_sig_and_print( c, n1 );
     }
     else if( node->pkt->pkttype == PKT_SIGNATURE ) {
 	PKT_signature *sig = node->pkt->pkt.signature;
diff -urN g10-0.2.3/g10/packet.h g10-0.2.4/g10/packet.h
--- g10-0.2.3/g10/packet.h	Fri Jan 30 17:09:15 1998
+++ g10-0.2.4/g10/packet.h	Tue Feb 10 16:51:28 1998
@@ -221,6 +221,9 @@
 int set_packet_list_mode( int mode );
 int search_packet( IOBUF inp, PACKET *pkt, int pkttype, ulong *retpos );
 int parse_packet( IOBUF inp, PACKET *ret_pkt);
+int copy_all_packets( IOBUF inp, IOBUF out );
+int copy_some_packets( IOBUF inp, IOBUF out, ulong stopoff );
+int skip_some_packets( IOBUF inp, unsigned n );
 
 /*-- build-packet.c --*/
 int build_packet( IOBUF inp, PACKET *pkt );
diff -urN g10-0.2.3/g10/parse-packet.c g10-0.2.4/g10/parse-packet.c
--- g10-0.2.3/g10/parse-packet.c	Mon Feb  9 17:20:39 1998
+++ g10-0.2.4/g10/parse-packet.c	Tue Feb 10 18:52:52 1998
@@ -37,7 +37,9 @@
 static list_mode = 0;
 
 static int  parse( IOBUF inp, PACKET *pkt, int reqtype,
-					   ulong *retpos, int *skip );
+		   ulong *retpos, int *skip, IOBUF out, int do_skip );
+static int  copy_packet( IOBUF inp, IOBUF out, int pkttype,
+					       unsigned long pktlen );
 static void skip_packet( IOBUF inp, int pkttype, unsigned long pktlen );
 static void skip_rest( IOBUF inp, unsigned long pktlen );
 static int  parse_publickey( IOBUF inp, int pkttype, unsigned long pktlen,
@@ -51,7 +53,8 @@
 static int  parse_user_id( IOBUF inp, int pkttype, unsigned long pktlen,
 							   PACKET *packet );
 static void parse_subkey( IOBUF inp, int pkttype, unsigned long pktlen );
-static void parse_comment( IOBUF inp, int pkttype, unsigned long pktlen );
+static int  parse_comment( IOBUF inp, int pkttype, unsigned long pktlen,
+							   PACKET *packet );
 static void parse_trust( IOBUF inp, int pkttype, unsigned long pktlen );
 static int  parse_plaintext( IOBUF inp, int pkttype, unsigned long pktlen,
 								PACKET *pkt );
@@ -116,13 +119,13 @@
     int skip, rc;
 
     do {
-	rc = parse( inp, pkt, 0, NULL, &skip );
+	rc = parse( inp, pkt, 0, NULL, &skip, NULL, 0 );
     } while( skip );
     return rc;
 }
 
 /****************
- * Like parse packet, but do only return packet of the given type.
+ * Like parse packet, but do only return packets of the given type.
  */
 int
 search_packet( IOBUF inp, PACKET *pkt, int pkttype, ulong *retpos )
@@ -130,20 +133,68 @@
     int skip, rc;
 
     do {
-	rc = parse( inp, pkt, pkttype, retpos, &skip );
+	rc = parse( inp, pkt, pkttype, retpos, &skip, NULL, 0 );
     } while( skip );
     return rc;
 }
 
+/****************
+ * Copy all packets from INP to OUT, thereby removing unused spaces.
+ */
+int
+copy_all_packets( IOBUF inp, IOBUF out )
+{
+    PACKET pkt;
+    int skip, rc=0;
+    do {
+	init_packet(&pkt);
+    } while( !(rc = parse( inp, &pkt, 0, NULL, &skip, out, 0 )));
+    return rc;
+}
+
+/****************
+ * Copy some packets from INP to OUT, thereby removing unused spaces.
+ * Stop after at offset STOPoff (i.e. don't copy the packet at this offset)
+ */
+int
+copy_some_packets( IOBUF inp, IOBUF out, ulong stopoff )
+{
+    PACKET pkt;
+    int skip, rc=0;
+    do {
+	if( iobuf_tell(inp) >= stopoff )
+	    return 0;
+	init_packet(&pkt);
+    } while( !(rc = parse( inp, &pkt, 0, NULL, &skip, out, 0 )) );
+    return rc;
+}
+
+/****************
+ * Skip over N packets
+ */
+int
+skip_some_packets( IOBUF inp, unsigned n )
+{
+    int skip, rc=0;
+    PACKET pkt;
+
+    for( ;n && !rc; n--) {
+	init_packet(&pkt);
+	rc = parse( inp, &pkt, 0, NULL, &skip, NULL, 1 );
+    }
+    return rc;
+}
 
 /****************
  * Parse packet. Set the variable skip points to to 1 if the packet
  * should be skipped; this is the case if either there is a
  * requested packet type and the parsed packet doesn't match or the
  * packet-type is 0, indicating deleted stuff.
+ * if OUT is not NULL, a special copymode is used.
  */
 static int
-parse( IOBUF inp, PACKET *pkt, int reqtype, ulong *retpos, int *skip )
+parse( IOBUF inp, PACKET *pkt, int reqtype, ulong *retpos,
+       int *skip, IOBUF out, int do_skip )
 {
     int rc, c, ctb, pkttype, lenbytes;
     unsigned long pktlen;
@@ -206,7 +257,15 @@
 	}
     }
 
-    if( !pkttype || (reqtype && pkttype != reqtype) ) {
+    if( out && pkttype	) {
+	if( iobuf_write( out, hdr, hdrlen ) == -1 )
+	    rc = G10ERR_WRITE_FILE;
+	else
+	    rc = copy_packet(inp, out, pkttype, pktlen );
+	return rc;
+    }
+
+    if( do_skip || !pkttype || (reqtype && pkttype != reqtype) ) {
 	skip_packet(inp, pkttype, pktlen);
 	*skip = 1;
 	return 0;
@@ -245,7 +304,7 @@
 	parse_subkey(inp, pkttype, pktlen);
 	break;
       case PKT_COMMENT:
-	parse_comment(inp, pkttype, pktlen);
+	rc = parse_comment(inp, pkttype, pktlen, pkt);
 	break;
       case PKT_RING_TRUST:
 	parse_trust(inp, pkttype, pktlen);
@@ -284,6 +343,37 @@
 }
 
 
+static int
+copy_packet( IOBUF inp, IOBUF out, int pkttype, unsigned long pktlen )
+{
+    int n;
+    char buf[100];
+
+    if( iobuf_in_block_mode(inp) ) {
+	while( (n = iobuf_read( inp, buf, 100 )) != -1 )
+	    if( iobuf_write(out, buf, n ) )
+		return G10ERR_WRITE_FILE; /* write error */
+    }
+    else if( !pktlen && pkttype == PKT_COMPRESSED ) {
+	/* compressed packet, copy till EOF */
+	while( (n = iobuf_read( inp, buf, 100 )) != -1 )
+	    if( iobuf_write(out, buf, n ) )
+		return G10ERR_WRITE_FILE; /* write error */
+    }
+    else {
+	for( ; pktlen; pktlen -= n ) {
+	    n = pktlen > 100 ? 100 : pktlen;
+	    n = iobuf_read( inp, buf, n );
+	    if( n == -1 )
+		return G10ERR_READ_FILE;
+	    if( iobuf_write(out, buf, n ) )
+		return G10ERR_WRITE_FILE; /* write error */
+	}
+    }
+    return 0;
+}
+
+
 static void
 skip_packet( IOBUF inp, int pkttype, unsigned long pktlen )
 {
@@ -738,22 +828,29 @@
 
 
 
-static void
-parse_comment( IOBUF inp, int pkttype, unsigned long pktlen )
+static int
+parse_comment( IOBUF inp, int pkttype, unsigned long pktlen, PACKET *packet )
 {
+    byte *p;
+
+    packet->pkt.comment = m_alloc(sizeof *packet->pkt.comment + pktlen - 1);
+    packet->pkt.comment->len = pktlen;
+    p = packet->pkt.comment->data;
+    for( ; pktlen; pktlen--, p++ )
+	*p = iobuf_get_noeof(inp);
+
     if( list_mode ) {
-	printf(":comment packet: \"" );
-	for( ; pktlen; pktlen-- ) {
-	    int c;
-	    c = iobuf_get_noeof(inp);
-	    if( c >= ' ' && c <= 'z' )
-		putchar(c);
+	int n = packet->pkt.comment->len;
+	printf(":comment packet: \"");
+	for(p=packet->pkt.comment->data; n; p++, n-- ) {
+	    if( *p >= ' ' && *p <= 'z' )
+		putchar(*p);
 	    else
-		printf("\\x%02x", c );
+		printf("\\x%02x", *p );
 	}
 	printf("\"\n");
     }
-    skip_rest(inp, pktlen);
+    return 0;
 }
 
 
@@ -765,33 +862,6 @@
     c = iobuf_get_noeof(inp);
     if( list_mode )
 	printf(":trust packet: flag=%02x\n", c );
-  #if 0 /* fixme: depending on the context we have different interpretations*/
-    if( prev_packet_is_a_key_packet ) {
-	int ot = c & 7;   /* ownertrust bits (for the key owner) */
-
-	    !ot ? "undefined" :
-	ot == 1 ? "unknown"   : /* we don't know the owner of this key */
-	ot == 2 ? "no"        : /* usually we do not trust this key owner */
-				/* to sign other keys */
-	ot == 5 ? "usually"   : /* usually we trust this key owner to sign */
-	ot == 6 ? "always"    : /* always trust this key owner to sign */
-	ot == 7 ? "ultimate"  : /* also present in the secret keyring */
-	      ""                /* reserved value */
-	if( c & (1<<5) )
-	    "key is disabled"
-	if( c & (1<<7) )
-	    "buckstop"
-    else if( prev_packet_is_user_is_packet ) {
-	    int kl = c & 3; /* keylegit bits */
-	0 = "unknown, undefined, or uninitialized trust"
-	1 = "we do not trust this key's ownership"
-	2 = "we have marginal confidence of this key's ownership"
-	3 = "we completely trust this key's ownership."
-	if( c & 0x80 )
-	    "warnonly"
-    else if( prev_packet_is_a_signature ) {
-    }
-  #endif
 }
 
 
diff -urN g10-0.2.3/g10/pkclist.c g10-0.2.4/g10/pkclist.c
--- g10-0.2.3/g10/pkclist.c	Mon Jan 26 22:44:05 1998
+++ g10-0.2.4/g10/pkclist.c	Wed Feb 11 21:35:24 1998
@@ -213,11 +213,13 @@
 	return 1; /* yes */
 
       case TRUST_FULLY:
-	log_info("This key probably belongs to the owner\n");
+	if( opt.verbose )
+	    log_info("This key probably belongs to the owner\n");
 	return 1; /* yes */
 
       case TRUST_ULTIMATE:
-	log_info("Our own keys is always good.\n");
+	if( opt.verbose )
+	    log_info("This key belongs to us (we have the secret key)\n");
 	return 1; /* yes */
 
       default: BUG();
diff -urN g10-0.2.3/g10/plaintext.c g10-0.2.4/g10/plaintext.c
--- g10-0.2.3/g10/plaintext.c	Mon Feb  9 17:31:54 1998
+++ g10-0.2.4/g10/plaintext.c	Wed Feb 11 22:02:56 1998
@@ -45,10 +45,7 @@
     FILE *fp = NULL;
     int rc = 0;
     int c;
-static FILE *abc;
-if( !abc )
-    abc=fopen("plaintext.out", "wb");
-if( !abc ) BUG();
+    int convert = pt->mode == 't';
 
     /* create the filename as C string */
     if( opt.outfile ) {
@@ -82,9 +79,10 @@
 		rc = G10ERR_READ_FILE;
 		goto leave;
 	    }
-	    putc( c, abc );
 	    if( mfx->md )
 		md_putc(mfx->md, c );
+	    if( convert && c == '\r' )
+		continue; /* FIXME: this hack is too simple */
 	    if( putc( c, fp ) == EOF ) {
 		log_error("Error writing to '%s': %s\n", fname, strerror(errno) );
 		rc = G10ERR_WRITE_FILE;
@@ -94,9 +92,10 @@
     }
     else {
 	while( (c = iobuf_get(pt->buf)) != -1 ) {
-	    putc( c, abc );
 	    if( mfx->md )
 		md_putc(mfx->md, c );
+	    if( convert && c == '\r' )
+		continue; /* FIXME: this hack is too simple */
 	    if( putc( c, fp ) == EOF ) {
 		log_error("Error writing to '%s': %s\n",
 					    fname, strerror(errno) );
@@ -136,7 +135,7 @@
     int c;
 
     fp = open_sigfile( inname ); /* open default file */
-    if( !fp ) {
+    if( !fp && !opt.batch ) {
 	int any=0;
 	tty_printf("Detached signature.\n");
 	do {
@@ -160,11 +159,20 @@
 	} while( !fp );
     }
 
-    while( (c = iobuf_get(fp)) != -1 ) {
-	if( mfx->md )
-	    md_putc(mfx->md, c );
+    if( !fp ) {
+	log_info("reading stdin ...\n");
+	while( (c = getchar()) != EOF ) {
+	    if( mfx->md )
+		md_putc(mfx->md, c );
+	}
+    }
+    else {
+	while( (c = iobuf_get(fp)) != -1 ) {
+	    if( mfx->md )
+		md_putc(mfx->md, c );
+	}
+	iobuf_close(fp);
     }
-    iobuf_close(fp);
 
   leave:
     m_free(answer);
diff -urN g10-0.2.3/g10/ringedit.c g10-0.2.4/g10/ringedit.c
--- g10-0.2.3/g10/ringedit.c	Tue Feb  3 13:04:02 1998
+++ g10-0.2.4/g10/ringedit.c	Tue Feb 10 22:48:27 1998
@@ -35,7 +35,6 @@
  *
  *  - Delete a key block
  *
- * FIXME:  Add backup stuff
  * FIXME:  Keep track of all nodes, so that a change is propagated
  *	   to all nodes. (or use shallow copies and ref-counting?)
  */
@@ -46,6 +45,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/stat.h>
 #include <assert.h>
 #include "util.h"
 #include "packet.h"
@@ -75,8 +77,7 @@
 static int keyring_search2( PUBKEY_FIND_INFO info, KBPOS *kbpos,
 						   const char *fname);
 static int keyring_read( KBPOS *kbpos, KBNODE *ret_root );
-static int keyring_insert( KBPOS *kbpos, KBNODE root );
-static int keyring_delete( KBPOS *kbpos );
+static int keyring_copy( KBPOS *kbpos, int mode, KBNODE root );
 
 
 
@@ -308,7 +309,7 @@
     if( !check_pos(kbpos) )
 	return G10ERR_GENERAL;
 
-    rc = keyring_insert( kbpos, root );
+    rc = keyring_copy( kbpos, 1, root );
 
     return rc;
 }
@@ -327,7 +328,7 @@
     if( !check_pos(kbpos) )
 	return G10ERR_GENERAL;
 
-    rc = keyring_delete( kbpos );
+    rc = keyring_copy( kbpos, 2, NULL );
 
     return rc;
 }
@@ -340,14 +341,11 @@
 update_keyblock( KBPOS *kbpos, KBNODE root )
 {
     int rc;
-    KBPOS kbpos2;
 
-    /* we do it the simple way: */
-    memset( &kbpos2, 0, sizeof kbpos2 );
-    kbpos2.resno = kbpos->resno;
-    rc = insert_keyblock( &kbpos2, root );
-    if( !rc )
-	rc = delete_keyblock( kbpos );
+    if( !check_pos(kbpos) )
+	return G10ERR_GENERAL;
+
+    rc = keyring_copy( kbpos, 3, root );
 
     return rc;
 }
@@ -451,20 +449,12 @@
     init_packet(&pkt);
     save_mode = set_packet_list_mode(0);
 
-  #if 0
-    if( iobuf_seek( iobuf, 0 ) ) {
-	log_error("can't rewind keyring file: %s\n", g10_errstr(rc));
-	rc = G10ERR_KEYRING_OPEN;
-	goto leave;
-    }
-  #else
     iobuf = iobuf_open( fname );
     if( !iobuf ) {
 	log_error("can't open '%s'\n", fname );
 	rc = G10ERR_OPEN_FILE;
 	goto leave;
     }
-  #endif
 
     while( !(rc=search_packet(iobuf, &pkt, PKT_PUBLIC_CERT, &offset)) ) {
 	PKT_public_cert *pkc = pkt.pkt.public_cert;
@@ -505,9 +495,8 @@
     int rc;
     RESTBL *rentry;
     KBNODE root = NULL;
-    KBNODE node, n1, n2;
     IOBUF a;
-    u32 offset, last_offset;
+    int in_cert = 0;
 
     if( !(rentry=check_pos(kbpos)) )
 	return G10ERR_GENERAL;
@@ -526,77 +515,37 @@
 
     pkt = m_alloc( sizeof *pkt );
     init_packet(pkt);
+    kbpos->count=0;
     while( (rc=parse_packet(a, pkt)) != -1 ) {
 	if( rc ) {  /* ignore errors */
+	    if( rc != G10ERR_UNKNOWN_PACKET ) {
+		log_error("read_keyblock: read error: %s\n", g10_errstr(rc) );
+		rc = G10ERR_INV_KEYRING;
+		goto ready;
+	    }
+	    kbpos->count++;
 	    free_packet( pkt );
 	    continue;
 	}
-	if( root && ( pkt->pkttype == PKT_PUBLIC_CERT
-		      || pkt->pkttype == PKT_SECRET_CERT ) )
-	    goto ready;
-	offset = iobuf_tell(a);
+	/* make a linked list of all packets */
 	switch( pkt->pkttype ) {
 	  case PKT_PUBLIC_CERT:
 	  case PKT_SECRET_CERT:
-	    root = new_kbnode( pkt );
-	    pkt = m_alloc( sizeof *pkt );
-	    init_packet(pkt);
-	    break;
-
-	  case PKT_USER_ID:
-	    if( !root ) {
-		log_error("read_keyblock: orphaned user id\n" );
-		rc = G10ERR_INV_KEYRING; /* or wrong kbpos */
+	    if( in_cert )
 		goto ready;
-	    }
-	    offset = last_offset;
-	    /* append the user id */
-	    node = new_kbnode( pkt );
-	    if( !(n1=root->child) )
-		root->child = node;
-	    else {
-		for( ; n1->next; n1 = n1->next)
-		    ;
-		n1->next = node;
-	    }
-	    pkt = m_alloc( sizeof *pkt );
-	    init_packet(pkt);
-	    break;
-
-	  case PKT_SIGNATURE:
-	    if( !root ) {
-		log_error("read_keyblock: no root for signature\n" );
-		rc = G10ERR_INV_KEYRING; /* or wrong kbpos */
-		break;
-	    }
-	    if( !root->child ) {
-		log_error("read_keyblock: no userid for signature\n" );
-		rc = G10ERR_INV_KEYRING;
-		break;
-	    }
-	    /* goto the last user id */
-	    for(n1=root->child; n1->next; n1 = n1->next )
-		;
-	    /* append the signature node */
-	    node = new_kbnode( pkt );
-	    if( !(n2=n1->child) )
-		n1->child = node;
-	    else {
-		for( ; n2->next; n2 = n2->next)
-		    ;
-		n2->next = node;
-	    }
+	    in_cert = 1;
+	  default:
+	    kbpos->count++;
+	    if( !root )
+		root = new_kbnode( pkt );
+	    else
+		add_kbnode( root, new_kbnode( pkt ) );
 	    pkt = m_alloc( sizeof *pkt );
 	    init_packet(pkt);
 	    break;
-
-	  default: /* ignore all other packets. FIXME: we should not do this */
-	    free_packet( pkt );
-	    break;
 	}
     }
   ready:
-    kbpos->last_block = rc == -1; /* flag, that this is the last block */
     if( rc == -1 && root )
 	rc = 0;
 
@@ -604,7 +553,6 @@
 	release_kbnode( root );
     else {
 	*ret_root = root;
-	kbpos->length = offset - kbpos->offset;
     }
     free_packet( pkt );
     m_free( pkt );
@@ -613,111 +561,175 @@
 }
 
 
+
 /****************
- * Insert the keyblock described by ROOT into the keyring described
- * by KBPOS.  This actually appends the data to the keyfile.
+ * Peromf insert/delete/update operation.
+ * mode 1 = insert
+ *	2 = delete
+ *	3 = update
  */
 static int
-keyring_insert( KBPOS *kbpos, KBNODE root )
+keyring_copy( KBPOS *kbpos, int mode, KBNODE root )
 {
     RESTBL *rentry;
-    IOBUF fp;
-    KBNODE kbctx, node;
+    IOBUF fp, newfp;
     int rc;
+    char *bakfname = NULL;
+    char *tmpfname = NULL;
 
     if( !(rentry = check_pos( kbpos )) )
 	return G10ERR_GENERAL;
 
-    /* FIXME: we must close the file if it's already open, due to
-     *	      2 reasons:
-     *	       - cannot open the same file twice on DOSish OSes
-     *	       - must sync with iobufs somehow
-     */
-    /* open the file for append */
-    fp = iobuf_append( rentry->fname );
-    if( !fp ) {
-	log_error("can't append to '%s'\n", rentry->fname );
-	return G10ERR_OPEN_FILE;
-    }
+    /* open the source file */
+    fp = iobuf_open( rentry->fname );
+    if( mode == 1 && !fp && errno == ENOENT ) { /* no file yet */
+	KBNODE kbctx, node;
+
+	/* insert: create a new file */
+	newfp = iobuf_create( rentry->fname );
+	if( !newfp ) {
+	    log_error("%s: can't create: %s\n", rentry->fname, strerror(errno));
+	    return G10ERR_OPEN_FILE;
+	}
 
-    kbctx=NULL;
-    while( (node = walk_kbtree( root, &kbctx )) ) {
-	if( (rc = build_packet( fp, node->pkt )) ) {
-	    log_error("build_packet(%d) failed: %s\n",
-			node->pkt->pkttype, g10_errstr(rc) );
+	kbctx=NULL;
+	while( (node = walk_kbnode( root, &kbctx, 0 )) ) {
+	    if( (rc = build_packet( newfp, node->pkt )) ) {
+		log_error("build_packet(%d) failed: %s\n",
+			    node->pkt->pkttype, g10_errstr(rc) );
+		iobuf_cancel(newfp);
+		return G10ERR_WRITE_FILE;
+	    }
+	}
+	if( iobuf_close(newfp) ) {
+	    log_error("%s: close failed: %s\n", rentry->fname, strerror(errno));
+	    return G10ERR_CLOSE_FILE;
+	}
+	if( chmod( rentry->fname, S_IRUSR | S_IWUSR ) ) {
+	    log_error("%s: chmod failed: %s\n",
+				    rentry->fname, strerror(errno) );
 	    return G10ERR_WRITE_FILE;
 	}
+	return 0;
     }
-    iobuf_close(fp);
-
-    return 0;
-}
-
-static int
-keyring_delete( KBPOS *kbpos )
-{
-    RESTBL *rentry;
-    IOBUF fp;
-    int rc;
-    u32 len;
-    int ctb;
-
-    if( !(rentry = check_pos( kbpos )) )
-	return G10ERR_GENERAL;
-
-
-    /* open the file for read/write */
-    fp = iobuf_openrw( rentry->fname );
     if( !fp ) {
-	log_error("can't open '%s' for writing\n", rentry->fname );
-	return G10ERR_OPEN_FILE;
+	log_error("%s: can't open: %s\n", rentry->fname, strerror(errno) );
+	rc = G10ERR_OPEN_FILE;
+	goto leave;
     }
 
-    if( iobuf_seek( fp, kbpos->offset ) ) {
-	log_error("can't seek to %lu: %s\n", kbpos->offset, g10_errstr(rc));
+    /* create the new file */
+    bakfname = m_alloc( strlen( rentry->fname ) + 2 );
+    strcpy(stpcpy(bakfname,rentry->fname),"~");
+    tmpfname = m_alloc( strlen( rentry->fname ) + 5 );
+    strcpy(stpcpy(tmpfname,rentry->fname),".tmp");
+    newfp = iobuf_create( tmpfname );
+    if( !newfp ) {
+	log_error("%s: can't create: %s\n", tmpfname, strerror(errno) );
 	iobuf_close(fp);
-	return G10ERR_WRITE_FILE;
+	rc = G10ERR_OPEN_FILE;
+	goto leave;
     }
 
-    len = kbpos->length;
-    assert( len < 100000 ); /* there is a bug somewhere */
-    /*log_debug("writing a dummy packet of length %lu\n", (ulong)len);*/
-
-    if( len < 2 )
-	BUG();
-
-    if( len < 256 ) {
-	ctb = 0x80;
-	len -= 2;
-    }
-    else if( len < 65536 ) {
-	ctb = 0x81;
-	len -= 3;
+    if( mode == 1 ) { /* insert */
+	/* copy everything to the new file */
+	rc = copy_all_packets( fp, newfp );
+	if( rc != -1 ) {
+	    log_error("%s: copy to %s failed: %s\n",
+		      rentry->fname, tmpfname, g10_errstr(rc) );
+	    iobuf_close(fp);
+	    iobuf_cancel(newfp);
+	    goto leave;
+	}
+	rc = 0;
     }
-    else {
-	ctb = 0x82;
-	len -= 5;
+
+    if( mode == 2 || mode == 3 ) { /* delete or update */
+	/* copy first part to the new file */
+	rc = copy_some_packets( fp, newfp, kbpos->offset );
+	if( rc ) { /* should never get EOF here */
+	    log_error("%s: copy to %s failed: %s\n",
+		      rentry->fname, tmpfname, g10_errstr(rc) );
+	    iobuf_close(fp);
+	    iobuf_cancel(newfp);
+	    goto leave;
+	}
+	/* skip this keyblock */
+	assert( kbpos->count );
+	rc = skip_some_packets( fp, kbpos->count );
+	if( rc ) {
+	    log_error("%s: skipping %u packets failed: %s\n",
+			    rentry->fname, kbpos->count, g10_errstr(rc));
+	    iobuf_close(fp);
+	    iobuf_cancel(newfp);
+	    goto leave;
+	}
     }
-    iobuf_put(fp, ctb );
-    if( ctb & 2 ) {
-	iobuf_put(fp, len >> 24 );
-	iobuf_put(fp, len >> 16 );
-    }
-    if( ctb & 3 )
-	iobuf_put(fp, len >> 8 );
-    if( iobuf_put(fp, len ) ) {
-	iobuf_close(fp);
-	return G10ERR_WRITE_FILE;
+
+    if( mode == 1 || mode == 3 ) { /* insert or update */
+	KBNODE kbctx, node;
+
+	/* append the new data */
+	kbctx=NULL;
+	while( (node = walk_kbnode( root, &kbctx, 0 )) ) {
+	    if( (rc = build_packet( newfp, node->pkt )) ) {
+		log_error("build_packet(%d) failed: %s\n",
+			    node->pkt->pkttype, g10_errstr(rc) );
+		iobuf_close(fp);
+		iobuf_cancel(newfp);
+		rc = G10ERR_WRITE_FILE;
+		goto leave;
+	    }
+	}
     }
-    for( ; len; len-- )
-	if( iobuf_put(fp, 0xff ) ) {
+
+    if( mode == 2 || mode == 3 ) { /* delete or update */
+	/* copy the rest */
+	rc = copy_all_packets( fp, newfp );
+	if( rc != -1 ) {
+	    log_error("%s: copy to %s failed: %s\n",
+		      rentry->fname, tmpfname, g10_errstr(rc) );
 	    iobuf_close(fp);
-	    return G10ERR_WRITE_FILE;
+	    iobuf_cancel(newfp);
+	    goto leave;
 	}
+	rc = 0;
+    }
 
+    /* close both files */
     iobuf_close(fp);
+    if( iobuf_close(newfp) ) {
+	log_error("%s: close failed: %s\n", tmpfname, strerror(errno) );
+	rc = G10ERR_CLOSE_FILE;
+	goto leave;
+    }
+    /* if the new file is a secring, restrict the permissions */
+    if( rentry->secret ) {
+	if( chmod( tmpfname, S_IRUSR | S_IWUSR ) ) {
+	    log_error("%s: chmod failed: %s\n",
+				    tmpfname, strerror(errno) );
+	    rc = G10ERR_WRITE_FILE;
+	    goto leave;
+	}
+    }
+    /* rename and make backup file */
+    if( rename( rentry->fname, bakfname ) ) {
+	log_error("%s: rename to %s failed: %s\n",
+				rentry->fname, bakfname, strerror(errno) );
+	rc = G10ERR_RENAME_FILE;
+	goto leave;
+    }
+    if( rename( tmpfname, rentry->fname ) ) {
+	log_error("%s: rename to %s failed: %s\n",
+			    tmpfname, rentry->fname,strerror(errno) );
+	rc = G10ERR_RENAME_FILE;
+	goto leave;
+    }
 
-    return 0;
+  leave:
+    m_free(bakfname);
+    m_free(tmpfname);
+    return rc;
 }
 
 
diff -urN g10-0.2.3/g10/seskey.c g10-0.2.4/g10/seskey.c
--- g10-0.2.3/g10/seskey.c	Fri Jan 16 12:47:22 1998
+++ g10-0.2.4/g10/seskey.c	Wed Feb 11 16:38:05 1998
@@ -109,8 +109,8 @@
  * returns: A mpi with the session key (caller must free)
  *  RMD160 Object ID is 1.3.36.3.2.1
  */
-MPI
-encode_rmd160_value( byte *md, unsigned len, unsigned nbits )
+static MPI
+encode_rmd160_value( byte *md, unsigned len, unsigned nbits, int secure )
 {
     static byte asn[15] =
 	  { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x24, 0x03,
@@ -128,7 +128,8 @@
      *
      * PAD consists of FF bytes.
      */
-    frame = mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB );
+    frame = secure ? mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB )
+		   : mpi_alloc( nframe / BYTES_PER_MPI_LIMB );
     n = 0;
     for(i=20-1; i >= 0; i--, n++ )
 	mpi_putbyte(frame, n, md[i] );
@@ -148,8 +149,8 @@
  * returns: A mpi with the session key (caller must free)
  *  SHA-1 Objet ID is 1.3.14.3.2.26
  */
-MPI
-encode_sha1_value( byte *md, unsigned len, unsigned nbits )
+static MPI
+encode_sha1_value( byte *md, unsigned len, unsigned nbits, int secure )
 {
     static byte asn[15] =
 	  { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x0e, 0x03,
@@ -167,7 +168,8 @@
      *
      * PAD consists of FF bytes.
      */
-    frame = mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB );
+    frame = secure ? mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB )
+		   : mpi_alloc( nframe / BYTES_PER_MPI_LIMB );
     n = 0;
     for(i=20-1; i >= 0; i--, n++ )
 	mpi_putbyte(frame, n, md[i] );
@@ -188,8 +190,8 @@
  * returns: A mpi with the session key (caller must free)
  *  MD5 Object ID is 1.2.840.113549.2.5
  */
-MPI
-encode_md5_value( byte *md, unsigned len, unsigned nbits )
+static MPI
+encode_md5_value( byte *md, unsigned len, unsigned nbits, int secure )
 {
     static byte asn[18] =
 	  { 0x30, 0x20, 0x30, 0x0c, 0x06, 0x08, 0x2a, 0x86,0x48,
@@ -207,7 +209,8 @@
      *
      * PAD consists of FF bytes.
      */
-    frame = mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB );
+    frame = secure ? mpi_alloc_secure( nframe / BYTES_PER_MPI_LIMB )
+		   : mpi_alloc( nframe / BYTES_PER_MPI_LIMB );
     n = 0;
     for(i=16-1; i >= 0; i--, n++ )
 	mpi_putbyte(frame, n, md[i] );
@@ -227,11 +230,14 @@
 {
     switch( md_get_algo( md ) ) {
       case DIGEST_ALGO_MD5:
-	return encode_md5_value( md_read(md, DIGEST_ALGO_MD5), 16, nbits );
+	return encode_md5_value( md_read(md, DIGEST_ALGO_MD5),
+				 16, nbits, md_is_secure(md) );
       case DIGEST_ALGO_RMD160:
-	return encode_rmd160_value( md_read(md, DIGEST_ALGO_RMD160), 20, nbits );
+	return encode_rmd160_value( md_read(md, DIGEST_ALGO_RMD160),
+				 20, nbits, md_is_secure(md) );
       case DIGEST_ALGO_SHA1:
-	return encode_sha1_value( md_read(md, DIGEST_ALGO_SHA1), 20, nbits );
+	return encode_sha1_value( md_read(md, DIGEST_ALGO_SHA1),
+				 20, nbits, md_is_secure(md) );
       default:
 	BUG();
     }
diff -urN g10-0.2.3/g10/sig-check.c g10-0.2.4/g10/sig-check.c
--- g10-0.2.3/g10/sig-check.c	Sat Jan 31 22:26:03 1998
+++ g10-0.2.4/g10/sig-check.c	Tue Feb 10 22:49:10 1998
@@ -248,9 +248,9 @@
     if( (rc=check_digest_algo(algo)) )
 	return rc;
 
-    unode = find_kbparent( root, node );
+    unode = find_prev_kbnode( root, node, PKT_USER_ID );
 
-    if( unode && unode->pkt->pkttype == PKT_USER_ID ) {
+    if( unode ) {
 	PKT_user_id *uid = unode->pkt->pkt.user_id;
 
 	if( is_selfsig ) {
diff -urN g10-0.2.3/g10/sign.c g10-0.2.4/g10/sign.c
--- g10-0.2.3/g10/sign.c	Mon Feb  9 17:55:00 1998
+++ g10-0.2.4/g10/sign.c	Wed Feb 11 22:50:53 1998
@@ -190,11 +190,13 @@
     /* setup the inner packet */
     if( detached ) {
 	if( multifile ) {
-	    STRLIST sl = filenames;
+	    STRLIST sl;
 
 	    if( opt.verbose )
 		log_info("signing:" );
-	    for(; sl; sl = sl->next ) {
+	    /* must walk reverse trough this list */
+	    for( sl = strlist_last(filenames); sl;
+			sl = strlist_prev( filenames, sl ) ) {
 		if( !(inp = iobuf_open(sl->d)) ) {
 		    log_error("can't open %s: %s\n", sl->d, strerror(errno) );
 		    rc = G10ERR_OPEN_FILE;
@@ -345,7 +347,7 @@
     armor_filter_context_t afx;
     compress_filter_context_t zfx;
     text_filter_context_t tfx;
-    MD_HANDLE textmd;
+    MD_HANDLE textmd = NULL;
     IOBUF inp = NULL, out = NULL;
     PACKET pkt;
     int rc = 0;
@@ -527,7 +529,7 @@
     int no_key = 0;
     int oth_err = 0;
 
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	if( node->pkt->pkttype == PKT_SIGNATURE
 	    && (node->pkt->pkt.signature->sig_class&~3) == 0x10 ) {
 	    PKT_signature *sig = node->pkt->pkt.signature;
@@ -579,7 +581,7 @@
     int count;
 
     count = 0;
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	if( ((node->flag & 7) || all )
 	    && node->pkt->pkttype == PKT_SIGNATURE
 	    && (node->pkt->pkt.signature->sig_class&~3) == 0x10 ) {
@@ -625,7 +627,7 @@
     if( !yes )
 	return 0;
 
-    for( kbctx=NULL; (node=walk_kbtree2( keyblock, &kbctx, 1)) ; ) {
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 1)) ; ) {
 	if( node->flag & 128)
 	    delete_kbnode( keyblock, node );
     }
@@ -677,10 +679,7 @@
     }
 
     /* get the keyid from the keyblock */
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
-	if( node->pkt->pkttype == PKT_PUBLIC_CERT )
-	    break;
-    }
+    node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
     if( !node ) {
 	log_error("Oops; public key not found anymore!\n");
 	rc = G10ERR_GENERAL;
@@ -719,7 +718,7 @@
 	u32 akeyid[2];
 
 	keyid_from_skc( skc_rover->skc, akeyid );
-	for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+	for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	    if( node->pkt->pkttype == PKT_SIGNATURE
 		&& (node->pkt->pkt.signature->sig_class&~3) == 0x10 ) {
 		if( akeyid[0] == node->pkt->pkt.signature->keyid[0]
@@ -744,7 +743,7 @@
     for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
 	if( skc_rover->mark )
 	    continue;
-	for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+	for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	    if( node->pkt->pkttype == PKT_USER_ID ) {
 		if( sign_it_p( pkc, node->pkt->pkt.user_id ) ) {
 		    PACKET *pkt;
@@ -763,7 +762,7 @@
 		    pkt = m_alloc_clear( sizeof *pkt );
 		    pkt->pkttype = PKT_SIGNATURE;
 		    pkt->pkt.signature = sig;
-		    add_kbnode_as_child( node, new_kbnode( pkt ) );
+		    insert_kbnode( node, new_kbnode(pkt), PKT_USER_ID );
 		}
 	    }
 	}
@@ -789,7 +788,7 @@
 {
     int rc = 0;
     KBNODE keyblock = NULL;
-    KBNODE kbctx, node;
+    KBNODE node;
     KBPOS kbpos;
     PKT_public_cert *pkc;
     u32 pkc_keyid[2];
@@ -809,10 +808,7 @@
     }
 
     /* get the keyid from the keyblock */
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
-	if( node->pkt->pkttype == PKT_PUBLIC_CERT )
-	    break;
-    }
+    node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
     if( !node ) {
 	log_error("Oops; public key not found anymore!\n");
 	rc = G10ERR_GENERAL;
@@ -855,7 +851,7 @@
 {
     int rc = 0;
     KBNODE keyblock = NULL;
-    KBNODE kbctx, node;
+    KBNODE node;
     KBPOS kbpos;
     PKT_secret_cert *skc;
     u32 skc_keyid[2];
@@ -877,10 +873,7 @@
     }
 
     /* get the keyid from the keyblock */
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
-	if( node->pkt->pkttype == PKT_SECRET_CERT )
-	    break;
-    }
+    node = find_kbnode( keyblock, PKT_SECRET_CERT );
     if( !node ) {
 	log_error("Oops; secret key not found anymore!\n");
 	rc = G10ERR_GENERAL;
diff -urN g10-0.2.3/g10/trustdb.c g10-0.2.4/g10/trustdb.c
--- g10-0.2.3/g10/trustdb.c	Mon Feb  2 20:55:49 1998
+++ g10-0.2.4/g10/trustdb.c	Wed Feb 11 21:31:19 1998
@@ -1090,7 +1090,7 @@
     LOCAL_ID_INFO *dups = NULL;
 
     *selfsig_okay = 0;
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx,0)) ; ) {
 	if( node->pkt->pkttype == PKT_SIGNATURE
 	    && (node->pkt->pkt.signature->sig_class&~3) == 0x10 ) {
 	    int selfsig;
@@ -1190,7 +1190,7 @@
     rec.rectype = RECTYPE_SIG;
     i = 0;
     rnum = rnum2 = 0;
-    for( kbctx=NULL; (node=walk_kbtree( keyblock, &kbctx)) ; ) {
+    for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	/* insert sigs which are not a selfsig nor a duplicate */
 	if( (node->flag & 1) && !(node->flag & 4) ) {
 	    assert( node->pkt->pkttype == PKT_SIGNATURE );
@@ -1423,10 +1423,13 @@
 	if( tsl->dup )
 	    continue;
 
-	log_debug("tslist segs:" );
-	for(i=0; i < tsl->nseg; i++ )
-	    fprintf(stderr, "  %lu/%02x", tsl->seg[i].lid, tsl->seg[i].trust );
-	putc('\n',stderr);
+	if( opt.verbose ) {
+	    log_info("tslist segs:" );
+	    for(i=0; i < tsl->nseg; i++ )
+		fprintf(stderr, "  %lu/%02x", tsl->seg[i].lid,
+						tsl->seg[i].trust );
+	    putc('\n',stderr);
+	}
     }
 
     /* and look wether there is a trusted path.
diff -urN g10-0.2.3/include/errors.h g10-0.2.4/include/errors.h
--- g10-0.2.3/include/errors.h	Mon Jan 26 13:40:54 1998
+++ g10-0.2.4/include/errors.h	Tue Feb 10 13:17:16 1998
@@ -55,5 +55,8 @@
 #define G10ERR_TRUSTDB	      33 /* a problem with the trustdb */
 #define G10ERR_BAD_CERT       34 /* bad certicate */
 #define G10ERR_INV_USER_ID    35
+#define G10ERR_CLOSE_FILE     36
+#define G10ERR_RENAME_FILE    37
+#define G10ERR_DELETE_FILE    38
 
 #endif /*G10_ERRORS_H*/
diff -urN g10-0.2.3/include/i18n.h g10-0.2.4/include/i18n.h
--- g10-0.2.3/include/i18n.h	Mon Feb  9 12:50:17 1998
+++ g10-0.2.4/include/i18n.h	Tue Feb 10 10:42:51 1998
@@ -21,6 +21,10 @@
 #ifndef G10_I18N_H
 #define G10_I18N_H
 
+#ifdef HAVE_LOCALE_H
+  #include <locale.h>	/* suggested by Ernst Molitor */
+#endif
+
 #ifdef HAVE_LIBINTL
   #include <libintl.h>
   #define _(a) gettext (a)
diff -urN g10-0.2.3/include/iobuf.h g10-0.2.4/include/iobuf.h
--- g10-0.2.3/include/iobuf.h	Wed Feb  4 14:12:12 1998
+++ g10-0.2.4/include/iobuf.h	Tue Feb 10 12:30:52 1998
@@ -88,6 +88,7 @@
 int   iobuf_seek( IOBUF a, ulong newpos );
 
 int  iobuf_readbyte(IOBUF a);
+int  iobuf_read(IOBUF a, byte *buf, unsigned buflen );
 int  iobuf_writebyte(IOBUF a, unsigned c);
 int  iobuf_write(IOBUF a, byte *buf, unsigned buflen );
 int  iobuf_writestr(IOBUF a, const char *buf );
diff -urN g10-0.2.3/include/memory.h g10-0.2.4/include/memory.h
--- g10-0.2.3/include/memory.h	Wed Jan 28 15:20:53 1998
+++ g10-0.2.4/include/memory.h	Wed Feb 11 01:31:27 1998
@@ -67,6 +67,8 @@
 void *secmem_malloc( size_t size );
 void secmem_free( void *a );
 void secmem_dump_stats(void);
+void secmem_set_flags( unsigned flags );
+unsigned secmem_get_flags(void);
 
 
 
diff -urN g10-0.2.3/include/mpi.h g10-0.2.4/include/mpi.h
--- g10-0.2.3/include/mpi.h	Mon Feb  2 12:38:16 1998
+++ g10-0.2.4/include/mpi.h	Wed Feb 11 01:31:27 1998
@@ -132,6 +132,9 @@
 void mpi_pow( MPI w, MPI u, MPI v);
 void mpi_powm( MPI res, MPI base, MPI exp, MPI mod);
 
+/*-- mpi-mpow.c --*/
+void mpi_mulpowm( MPI res, MPI *basearray, MPI *exparray, MPI mod);
+
 /*-- mpi-cmp.c --*/
 int mpi_cmp_ui( MPI u, ulong v );
 int mpi_cmp( MPI u, MPI v );
diff -urN g10-0.2.3/include/util.h g10-0.2.4/include/util.h
--- g10-0.2.3/include/util.h	Mon Jan 26 13:47:45 1998
+++ g10-0.2.4/include/util.h	Wed Feb 11 01:31:27 1998
@@ -66,20 +66,22 @@
 			    __attribute__ ((format (printf,2,3)));
   void log_bug( const char *fmt, ... )
 			    __attribute__ ((noreturn, format (printf,1,2)));
-  void log_bug0( void ) __attribute__ ((noreturn));
+  void log_bug0( const char *, int, const char * ) __attribute__ ((noreturn));
   void log_fatal( const char *fmt, ... )
 			    __attribute__ ((noreturn, format (printf,1,2)));
   void log_error( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
   void log_info( const char *fmt, ... )  __attribute__ ((format (printf,1,2)));
   void log_debug( const char *fmt, ... ) __attribute__ ((format (printf,1,2)));
+  #define BUG() log_bug0(  __FILE__ , __LINE__, __FUNCTION__ )
 #else
   void printstr( int level, const char *fmt, ... );
   void log_bug( const char *fmt, ... );
-  void log_bug0( void );
+  void log_bug0( const char *, int );
   void log_fatal( const char *fmt, ... );
   void log_error( const char *fmt, ... );
   void log_info( const char *fmt, ... );
   void log_debug( const char *fmt, ... );
+  #define BUG() log_bug0( __FILE__ , __LINE__ )
 #endif
 
 
@@ -110,6 +112,8 @@
 void free_strlist( STRLIST sl );
 #define FREE_STRLIST(a) do { free_strlist((a)); (a) = NULL ; } while(0)
 void add_to_strlist( STRLIST *list, const char *string );
+STRLIST strlist_prev( STRLIST head, STRLIST node );
+STRLIST strlist_last( STRLIST node );
 char *memistr( char *buf, size_t buflen, const char *sub );
 char *mem2str( char *, const void *, size_t);
 char *trim_spaces( char *string );
@@ -133,6 +137,5 @@
 #define STR2(v) STR(v)
 #define DIM(v) (sizeof(v)/sizeof((v)[0]))
 #define DIMof(type,member)   DIM(((type *)0)->member)
-#define BUG() log_bug0()
 
 #endif /*G10_UTIL_H*/
diff -urN g10-0.2.3/mpi/ChangeLog g10-0.2.4/mpi/ChangeLog
--- g10-0.2.3/mpi/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/mpi/Makefile.am g10-0.2.4/mpi/Makefile.am
--- g10-0.2.3/mpi/Makefile.am	Mon Feb  9 12:12:32 1998
+++ g10-0.2.4/mpi/Makefile.am	Wed Feb 11 01:07:20 1998
@@ -24,6 +24,7 @@
 	      mpi-inv.c      \
 	      mpi-mul.c      \
 	      mpi-pow.c      \
+	      mpi-mpow.c     \
 	      mpi-scan.c     \
 	      mpicoder.c     \
 	      mpih-cmp.c     \
diff -urN g10-0.2.3/mpi/Makefile.in g10-0.2.4/mpi/Makefile.in
--- g10-0.2.3/mpi/Makefile.in	Mon Feb  9 18:04:35 1998
+++ g10-0.2.4/mpi/Makefile.in	Wed Feb 11 23:19:59 1998
@@ -106,6 +106,7 @@
 	      mpi-inv.c      \
 	      mpi-mul.c      \
 	      mpi-pow.c      \
+	      mpi-mpow.c     \
 	      mpi-scan.c     \
 	      mpicoder.c     \
 	      mpih-cmp.c     \
@@ -138,13 +139,13 @@
 libmpi_a_DEPENDENCIES =  mpih-mul1.o mpih-mul2.o mpih-mul3.o mpih-add1.o \
 mpih-sub1.o mpih-shift.o
 libmpi_a_OBJECTS =  mpi-add.o mpi-bit.o mpi-cmp.o mpi-div.o mpi-gcd.o \
-mpi-inv.o mpi-mul.o mpi-pow.o mpi-scan.o mpicoder.o mpih-cmp.o \
-mpih-add.o mpih-sub.o mpih-div.o mpih-mul.o mpiutil.o
+mpi-inv.o mpi-mul.o mpi-pow.o mpi-mpow.o mpi-scan.o mpicoder.o \
+mpih-cmp.o mpih-add.o mpih-sub.o mpih-div.o mpih-mul.o mpiutil.o
 AR = ar
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
@@ -242,8 +243,12 @@
 	../include/types.h ../include/memory.h mpi-inline.h longlong.h
 mpi-gcd.o: mpi-gcd.c mpi-internal.h ../include/mpi.h ../include/iobuf.h \
 	../include/types.h ../include/memory.h mpi-inline.h
-mpi-inv.o: mpi-inv.c mpi-internal.h ../include/mpi.h ../include/iobuf.h \
-	../include/types.h ../include/memory.h mpi-inline.h
+mpi-inv.o mpi-inv.lo: mpi-inv.c ../config.h mpi-internal.h \
+	../include/mpi.h ../include/iobuf.h ../include/types.h \
+	../include/memory.h mpi-inline.h
+mpi-mpow.o mpi-mpow.lo: mpi-mpow.c ../config.h mpi-internal.h \
+	../include/mpi.h ../include/iobuf.h ../include/types.h \
+	../include/memory.h mpi-inline.h longlong.h
 mpi-mul.o: mpi-mul.c mpi-internal.h ../include/mpi.h ../include/iobuf.h \
 	../include/types.h ../include/memory.h mpi-inline.h
 mpi-pow.o: mpi-pow.c mpi-internal.h ../include/mpi.h ../include/iobuf.h \
diff -urN g10-0.2.3/mpi/alpha/README g10-0.2.4/mpi/alpha/README
--- g10-0.2.3/mpi/alpha/README	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/alpha/README	Mon Dec 22 21:28:29 1997
@@ -0,0 +1,53 @@
+This directory contains mpn functions optimized for DEC Alpha processors.
+
+RELEVANT OPTIMIZATION ISSUES
+
+EV4
+
+1. This chip has very limited store bandwidth.  The on-chip L1 cache is
+write-through, and a cache line is transfered from the store buffer to the
+off-chip L2 in as much 15 cycles on most systems.  This delay hurts
+mpn_add_n, mpn_sub_n, mpn_lshift, and mpn_rshift.
+
+2. Pairing is possible between memory instructions and integer arithmetic
+instructions.
+
+3. mulq and umulh is documented to have a latency of 23 cycles, but 2 of
+these cycles are pipelined.  Thus, multiply instructions can be issued at a
+rate of one each 21nd cycle.
+
+EV5
+
+1. The memory bandwidth of this chip seems excellent, both for loads and
+stores.  Even when the working set is larger than the on-chip L1 and L2
+caches, the perfromance remain almost unaffected.
+
+2. mulq has a measured latency of 13 cycles and an issue rate of 1 each 8th
+cycle.  umulh has a measured latency of 15 cycles and an issue rate of 1
+each 10th cycle.  But the exact timing is somewhat confusing.
+
+3. mpn_add_n.  With 4-fold unrolling, we need 37 instructions, whereof 12
+   are memory operations.  This will take at least
+	ceil(37/2) [dual issue] + 1 [taken branch] = 20 cycles
+   We have 12 memory cycles, plus 4 after-store conflict cycles, or 16 data
+   cache cycles, which should be completely hidden in the 20 issue cycles.
+   The computation is inherently serial, with these dependencies:
+     addq
+     /   \
+   addq  cmpult
+     |     |
+   cmpult  |
+       \  /
+        or
+   I.e., there is a 4 cycle path for each limb, making 16 cycles the absolute
+   minimum.  We could replace the `or' with a cmoveq/cmovne, which would save
+   a cycle on EV5, but that might waste a cycle on EV4.  Also, cmov takes 2
+   cycles.
+     addq
+     /   \
+   addq  cmpult
+     |      \
+   cmpult -> cmovne
+
+STATUS
+
diff -urN g10-0.2.3/mpi/alpha/distfiles g10-0.2.4/mpi/alpha/distfiles
--- g10-0.2.3/mpi/alpha/distfiles	Tue Dec 23 17:41:07 1997
+++ g10-0.2.4/mpi/alpha/distfiles	Wed Feb 11 14:47:27 1998
@@ -1,3 +1,6 @@
+README
+mpih-add1.S
+mpih-shift.S
 
 udiv-qrnnd.S
 
diff -urN g10-0.2.3/mpi/alpha/mpih-add1.S g10-0.2.4/mpi/alpha/mpih-add1.S
--- g10-0.2.3/mpi/alpha/mpih-add1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/alpha/mpih-add1.S	Wed Feb 11 14:38:19 1998
@@ -0,0 +1,134 @@
+/* alpha  add_n -- Add two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *
+ *	Copyright (C) 1995 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_add_n( mpi_ptr_t res_ptr,	($16)
+ *		   mpi_ptr_t s1_ptr,	($17)
+ *		   mpi_ptr_t s2_ptr,	($18)
+ *		   mpi_size_t size)	($19)
+ */
+
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	__mpihelp_add_n
+	.ent	__mpihelp_add_n
+__mpihelp_add_n:
+	.frame	$30,0,$26,0
+
+	ldq	$3,0($17)
+	ldq	$4,0($18)
+
+	subq	$19,1,$19
+	and	$19,4-1,$2	# number of limbs in first loop
+	bis	$31,$31,$0
+	beq	$2,.L0		# if multiple of 4 limbs, skip first loop
+
+	subq	$19,$2,$19
+
+.Loop0: subq	$2,1,$2
+	ldq	$5,8($17)
+	addq	$4,$0,$4
+	ldq	$6,8($18)
+	cmpult	$4,$0,$1
+	addq	$3,$4,$4
+	cmpult	$4,$3,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+
+	addq	$17,8,$17
+	addq	$18,8,$18
+	bis	$5,$5,$3
+	bis	$6,$6,$4
+	addq	$16,8,$16
+	bne	$2,.Loop0
+
+.L0:	beq	$19,.Lend
+
+	.align	3
+.Loop:	subq	$19,4,$19
+
+	ldq	$5,8($17)
+	addq	$4,$0,$4
+	ldq	$6,8($18)
+	cmpult	$4,$0,$1
+	addq	$3,$4,$4
+	cmpult	$4,$3,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+
+	ldq	$3,16($17)
+	addq	$6,$0,$6
+	ldq	$4,16($18)
+	cmpult	$6,$0,$1
+	addq	$5,$6,$6
+	cmpult	$6,$5,$0
+	stq	$6,8($16)
+	or	$0,$1,$0
+
+	ldq	$5,24($17)
+	addq	$4,$0,$4
+	ldq	$6,24($18)
+	cmpult	$4,$0,$1
+	addq	$3,$4,$4
+	cmpult	$4,$3,$0
+	stq	$4,16($16)
+	or	$0,$1,$0
+
+	ldq	$3,32($17)
+	addq	$6,$0,$6
+	ldq	$4,32($18)
+	cmpult	$6,$0,$1
+	addq	$5,$6,$6
+	cmpult	$6,$5,$0
+	stq	$6,24($16)
+	or	$0,$1,$0
+
+	addq	$17,32,$17
+	addq	$18,32,$18
+	addq	$16,32,$16
+	bne	$19,.Loop
+
+.Lend:	addq	$4,$0,$4
+	cmpult	$4,$0,$1
+	addq	$3,$4,$4
+	cmpult	$4,$3,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+	ret	$31,($26),1
+
+	.end	__mpihelp_add_n
+
diff -urN g10-0.2.3/mpi/alpha/mpih-shift.S g10-0.2.4/mpi/alpha/mpih-shift.S
--- g10-0.2.3/mpi/alpha/mpih-shift.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/alpha/mpih-shift.S	Wed Feb 11 14:47:02 1998
@@ -0,0 +1,213 @@
+/* alpha    rshift, lshift
+ *	Copyright (C) 1994, 1995 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(r16)
+ *		   mpi_ptr_t up,	(r17)
+ *		   mpi_size_t usize,	(r18)
+ *		   unsigned cnt)	(r19)
+ *
+ * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
+ * it would take 4 cycles/limb.  It should be possible to get down to 3
+ * cycles/limb since both ldq and stq can be paired with the other used
+ * instructions.  But there are many restrictions in the 21064 pipeline that
+ * makes it hard, if not impossible, to get down to 3 cycles/limb:
+ *
+ * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
+ * 2. Only aligned instruction pairs can be paired.
+ * 3. The store buffer or silo might not be able to deal with the bandwidth.
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	__mpihelp_lshift
+	.ent	__mpihelp_lshift
+__mpihelp_lshift:
+	.frame	$30,0,$26,0
+
+	s8addq	$18,$17,$17	# make r17 point at end of s1
+	ldq	$4,-8($17)	# load first limb
+	subq	$17,8,$17
+	subq	$31,$19,$7
+	s8addq	$18,$16,$16	# make r16 point at end of RES
+	subq	$18,1,$18
+	and	$18,4-1,$20	# number of limbs in first loop
+	srl	$4,$7,$0	# compute function result
+
+	beq	$20,.L0
+	subq	$18,$20,$18
+
+	.align	3
+.Loop0:
+	ldq	$3,-8($17)
+	subq	$16,8,$16
+	subq	$17,8,$17
+	subq	$20,1,$20
+	sll	$4,$19,$5
+	srl	$3,$7,$6
+	bis	$3,$3,$4
+	bis	$5,$6,$8
+	stq	$8,0($16)
+	bne	$20,.Loop0
+
+.L0:	beq	$18,.Lend
+
+	.align	3
+.Loop:	ldq	$3,-8($17)
+	subq	$16,32,$16
+	subq	$18,4,$18
+	sll	$4,$19,$5
+	srl	$3,$7,$6
+
+	ldq	$4,-16($17)
+	sll	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,24($16)
+	srl	$4,$7,$2
+
+	ldq	$3,-24($17)
+	sll	$4,$19,$5
+	bis	$1,$2,$8
+	stq	$8,16($16)
+	srl	$3,$7,$6
+
+	ldq	$4,-32($17)
+	sll	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,8($16)
+	srl	$4,$7,$2
+
+	subq	$17,32,$17
+	bis	$1,$2,$8
+	stq	$8,0($16)
+
+	bgt	$18,.Loop
+
+.Lend:	sll	$4,$19,$8
+	stq	$8,-8($16)
+	ret	$31,($26),1
+	.end	__mpihelp_lshift
+
+
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(r16)
+ *		   mpi_ptr_t up,	(r17)
+ *		   mpi_size_t usize,	(r18)
+ *		   unsigned cnt)	(r19)
+ *
+ * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
+ * it would take 4 cycles/limb.  It should be possible to get down to 3
+ * cycles/limb since both ldq and stq can be paired with the other used
+ * instructions.  But there are many restrictions in the 21064 pipeline that
+ * makes it hard, if not impossible, to get down to 3 cycles/limb:
+ *
+ * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
+ * 2. Only aligned instruction pairs can be paired.
+ * 3. The store buffer or silo might not be able to deal with the bandwidth.
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	__mpihelp_rshift
+	.ent	__mpihelp_rshift
+__mpihelp_rshift:
+	.frame	$30,0,$26,0
+
+	ldq	$4,0($17)	# load first limb
+	addq	$17,8,$17
+	subq	$31,$19,$7
+	subq	$18,1,$18
+	and	$18,4-1,$20	# number of limbs in first loop
+	sll	$4,$7,$0	# compute function result
+
+	beq	$20,.R0
+	subq	$18,$20,$18
+
+	.align	3
+.Roop0:
+	ldq	$3,0($17)
+	addq	$16,8,$16
+	addq	$17,8,$17
+	subq	$20,1,$20
+	srl	$4,$19,$5
+	sll	$3,$7,$6
+	bis	$3,$3,$4
+	bis	$5,$6,$8
+	stq	$8,-8($16)
+	bne	$20,.Roop0
+
+.R0:	beq	$18,.Rend
+
+	.align	3
+.Roop:	ldq	$3,0($17)
+	addq	$16,32,$16
+	subq	$18,4,$18
+	srl	$4,$19,$5
+	sll	$3,$7,$6
+
+	ldq	$4,8($17)
+	srl	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,-32($16)
+	sll	$4,$7,$2
+
+	ldq	$3,16($17)
+	srl	$4,$19,$5
+	bis	$1,$2,$8
+	stq	$8,-24($16)
+	sll	$3,$7,$6
+
+	ldq	$4,24($17)
+	srl	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,-16($16)
+	sll	$4,$7,$2
+
+	addq	$17,32,$17
+	bis	$1,$2,$8
+	stq	$8,-8($16)
+
+	bgt	$18,.Roop
+
+.Rend:	srl	$4,$19,$8
+	stq	$8,0($16)
+	ret	$31,($26),1
+	.end	__mpihelp_rshift
+
diff -urN g10-0.2.3/mpi/config.links g10-0.2.4/mpi/config.links
--- g10-0.2.3/mpi/config.links	Fri Jan 30 17:56:40 1998
+++ g10-0.2.4/mpi/config.links	Wed Feb 11 04:06:06 1998
@@ -10,7 +10,7 @@
 echo '/* created by config.links - do not edit */' >./mpi/asm-syntax.h
 
 case "${target}" in
-    i[345]86*-*-linuxaout* | i[345]86*-*-linuxoldld* | i[345]86*-*-*bsd*)
+    i[34]86*-*-linuxaout* | i[34]86*-*-linuxoldld* | i[34]86*-*-*bsd*)
 	echo '#define BSD_SYNTAX' >>./mpi/asm-syntax.h
 	cat  $srcdir/mpi/i386/syntax.h	    >>./mpi/asm-syntax.h
 	path="i386"
@@ -20,14 +20,14 @@
 	cat  $srcdir/mpi/i386/syntax.h	    >>./mpi/asm-syntax.h
 	path="i586 i386"
 	;;
-    i[3456]86*-*-*)
+    i[34]86*-*-*)
 	echo '#define ELF_SYNTAX' >>./mpi/asm-syntax.h
 	cat  $srcdir/mpi/i386/syntax.h	    >>./mpi/asm-syntax.h
 	path="i386"
 	;;
     i[56]86*-*-* | pentium-*-* | pentiumpro-*-*)
 	echo '#define ELF_SYNTAX' >>./mpi/asm-syntax.h
-	cat  $srcdir/mpi/i586/syntax.h	    >>./mpi/asm-syntax.h
+	cat  $srcdir/mpi/i386/syntax.h	    >>./mpi/asm-syntax.h
 	path="i586 i386"
 	;;
     alpha*-*-*)
diff -urN g10-0.2.3/mpi/i586/README g10-0.2.4/mpi/i586/README
--- g10-0.2.3/mpi/i586/README	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/README	Wed Feb 11 04:03:47 1998
@@ -0,0 +1,26 @@
+This directory contains mpn functions optimized for Intel Pentium
+processors.
+
+RELEVANT OPTIMIZATION ISSUES
+
+1. Pentium doesn't allocate cache lines on writes, unlike most other modern
+processors.  Since the functions in the mpn class do array writes, we have to
+handle allocating the destination cache lines by reading a word from it in the
+loops, to achieve the best performance.
+
+2. Pairing of memory operations requires that the two issued operations refer
+to different cache banks.  The simplest way to insure this is to read/write
+two words from the same object.  If we make operations on different objects,
+they might or might not be to the same cache bank.
+
+STATUS
+
+1. mpn_lshift and mpn_rshift run at about 6 cycles/limb, but the Pentium
+documentation indicates that they should take only 43/8 = 5.375 cycles/limb,
+or 5 cycles/limb asymptotically.
+
+2. mpn_add_n and mpn_sub_n run at asymptotically 2 cycles/limb.  Due to loop
+overhead and other delays (cache refill?), they run at or near 2.5 cycles/limb.
+
+3. mpn_mul_1, mpn_addmul_1, mpn_submul_1 all run 1 cycle faster than they
+should...
diff -urN g10-0.2.3/mpi/i586/distfiles g10-0.2.4/mpi/i586/distfiles
--- g10-0.2.3/mpi/i586/distfiles	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/distfiles	Wed Feb 11 04:03:50 1998
@@ -0,0 +1,8 @@
+mpih-add1.S
+mpih-mul1.S
+mpih-mul2.S
+mpih-mul3.S
+mpih-shift.S
+mpih-sub1.S
+README
+
diff -urN g10-0.2.3/mpi/i586/mpih-add1.S g10-0.2.4/mpi/i586/mpih-add1.S
--- g10-0.2.3/mpi/i586/mpih-add1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-add1.S	Wed Feb 11 03:48:03 1998
@@ -0,0 +1,134 @@
+/* i80586 add_n -- Add two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *
+ *	Copyright (C) 1992, 1994, 1995, 1996 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_add_n( mpi_ptr_t res_ptr,	(sp + 4)
+ *		   mpi_ptr_t s1_ptr,	(sp + 8)
+ *		   mpi_ptr_t s2_ptr,	(sp + 12)
+ *		   mpi_size_t size)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_add_n)
+C_SYMBOL_NAME(mpihelp_add_n:)
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s1_ptr */
+	movl	28(%esp),%ebp		/* s2_ptr */
+	movl	32(%esp),%ecx		/* size */
+
+	movl	(%ebp),%ebx
+
+	decl	%ecx
+	movl	%ecx,%edx
+	shrl	$3,%ecx
+	andl	$7,%edx
+	testl	%ecx,%ecx		/* zero carry flag */
+	jz	Lend
+	pushl	%edx
+
+	ALIGN (3)
+Loop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	leal	32(%edi),%edi
+
+L1:	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	adcl	%ebx,%eax
+	movl	4(%ebp),%ebx
+	adcl	%ebx,%edx
+	movl	8(%ebp),%ebx
+	movl	%eax,-32(%edi)
+	movl	%edx,-28(%edi)
+
+L2:	movl	8(%esi),%eax
+	movl	12(%esi),%edx
+	adcl	%ebx,%eax
+	movl	12(%ebp),%ebx
+	adcl	%ebx,%edx
+	movl	16(%ebp),%ebx
+	movl	%eax,-24(%edi)
+	movl	%edx,-20(%edi)
+
+L3:	movl	16(%esi),%eax
+	movl	20(%esi),%edx
+	adcl	%ebx,%eax
+	movl	20(%ebp),%ebx
+	adcl	%ebx,%edx
+	movl	24(%ebp),%ebx
+	movl	%eax,-16(%edi)
+	movl	%edx,-12(%edi)
+
+L4:	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	adcl	%ebx,%eax
+	movl	28(%ebp),%ebx
+	adcl	%ebx,%edx
+	movl	32(%ebp),%ebx
+	movl	%eax,-8(%edi)
+	movl	%edx,-4(%edi)
+
+	leal	32(%esi),%esi
+	leal	32(%ebp),%ebp
+	decl	%ecx
+	jnz	Loop
+
+	popl	%edx
+Lend:
+	decl	%edx			/* test %edx w/o clobbering carry */
+	js	Lend2
+	incl	%edx
+Loop2:
+	leal	4(%edi),%edi
+	movl	(%esi),%eax
+	adcl	%ebx,%eax
+	movl	4(%ebp),%ebx
+	movl	%eax,-4(%edi)
+	leal	4(%esi),%esi
+	leal	4(%ebp),%ebp
+	decl	%edx
+	jnz	Loop2
+Lend2:
+	movl	(%esi),%eax
+	adcl	%ebx,%eax
+	movl	%eax,(%edi)
+
+	sbbl	%eax,%eax
+	negl	%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+
diff -urN g10-0.2.3/mpi/i586/mpih-mul1.S g10-0.2.4/mpi/i586/mpih-mul1.S
--- g10-0.2.3/mpi/i586/mpih-mul1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-mul1.S	Wed Feb 11 04:02:36 1998
@@ -0,0 +1,89 @@
+/* i80586 mul_1 -- Multiply a limb vector with a limb and store
+ *			 the result in a second limb vector.
+ *	Copyright (C) 1992, 1994, 1996 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_mul_1( mpi_ptr_t res_ptr,	(sp + 4)
+ *		  mpi_ptr_t s1_ptr,	(sp + 8)
+ *		  mpi_size_t s1_size,	(sp + 12)
+ *		  mpi_limb_t s2_limb)	(sp + 16)
+ */
+
+#define res_ptr edi
+#define s1_ptr	esi
+#define size	ecx
+#define s2_limb ebp
+
+	TEXT
+	ALIGN (3)
+	GLOBL	C_SYMBOL_NAME(mpihelp_mul_1)
+C_SYMBOL_NAME(mpihelp_mul_1:)
+
+	INSN1(push,l	,R(edi))
+	INSN1(push,l	,R(esi))
+	INSN1(push,l	,R(ebx))
+	INSN1(push,l	,R(ebp))
+
+	INSN2(mov,l	,R(res_ptr),MEM_DISP(esp,20))
+	INSN2(mov,l	,R(s1_ptr),MEM_DISP(esp,24))
+	INSN2(mov,l	,R(size),MEM_DISP(esp,28))
+	INSN2(mov,l	,R(s2_limb),MEM_DISP(esp,32))
+
+	INSN2(lea,l	,R(res_ptr),MEM_INDEX(res_ptr,size,4))
+	INSN2(lea,l	,R(s1_ptr),MEM_INDEX(s1_ptr,size,4))
+	INSN1(neg,l	,R(size))
+	INSN2(xor,l	,R(ebx),R(ebx))
+	ALIGN (3)
+
+Loop:	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),MEM_INDEX(s1_ptr,size,4))
+
+	INSN1(mul,l	,R(s2_limb))
+
+	INSN2(add,l	,R(ebx),R(eax))
+
+	INSN2(mov,l	,MEM_INDEX(res_ptr,size,4),R(ebx))
+	INSN1(inc,l	,R(size))
+
+	INSN2(mov,l	,R(ebx),R(edx))
+	INSN1(jnz,	,Loop)
+
+	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),R(ebx))
+	INSN1(pop,l	,R(ebp))
+	INSN1(pop,l	,R(ebx))
+	INSN1(pop,l	,R(esi))
+	INSN1(pop,l	,R(edi))
+	ret
+
diff -urN g10-0.2.3/mpi/i586/mpih-mul2.S g10-0.2.4/mpi/i586/mpih-mul2.S
--- g10-0.2.3/mpi/i586/mpih-mul2.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-mul2.S	Wed Feb 11 03:55:04 1998
@@ -0,0 +1,94 @@
+/* i80586 addmul_1 -- Multiply a limb vector with a limb and add
+ *		      the result to a second limb vector.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_addmul_1( mpi_ptr_t res_ptr,      (sp + 4)
+ *		     mpi_ptr_t s1_ptr,	     (sp + 8)
+ *		     mpi_size_t s1_size,     (sp + 12)
+ *		     mpi_limb_t s2_limb)     (sp + 16)
+ */
+
+#define res_ptr edi
+#define s1_ptr	esi
+#define size	ecx
+#define s2_limb ebp
+
+	TEXT
+	ALIGN (3)
+	GLOBL	C_SYMBOL_NAME(mpihelp_addmul_1)
+C_SYMBOL_NAME(mpihelp_addmul_1:)
+
+	INSN1(push,l	,R(edi))
+	INSN1(push,l	,R(esi))
+	INSN1(push,l	,R(ebx))
+	INSN1(push,l	,R(ebp))
+
+	INSN2(mov,l	,R(res_ptr),MEM_DISP(esp,20))
+	INSN2(mov,l	,R(s1_ptr),MEM_DISP(esp,24))
+	INSN2(mov,l	,R(size),MEM_DISP(esp,28))
+	INSN2(mov,l	,R(s2_limb),MEM_DISP(esp,32))
+
+	INSN2(lea,l	,R(res_ptr),MEM_INDEX(res_ptr,size,4))
+	INSN2(lea,l	,R(s1_ptr),MEM_INDEX(s1_ptr,size,4))
+	INSN1(neg,l	,R(size))
+	INSN2(xor,l	,R(ebx),R(ebx))
+	ALIGN (3)
+
+Loop:	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),MEM_INDEX(s1_ptr,size,4))
+
+	INSN1(mul,l	,R(s2_limb))
+
+	INSN2(add,l	,R(eax),R(ebx))
+	INSN2(mov,l	,R(ebx),MEM_INDEX(res_ptr,size,4))
+
+	INSN2(adc,l	,R(edx),$0)
+	INSN2(add,l	,R(ebx),R(eax))
+
+	INSN2(mov,l	,MEM_INDEX(res_ptr,size,4),R(ebx))
+	INSN1(inc,l	,R(size))
+
+	INSN2(mov,l	,R(ebx),R(edx))
+	INSN1(jnz,	,Loop)
+
+	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),R(ebx))
+	INSN1(pop,l	,R(ebp))
+	INSN1(pop,l	,R(ebx))
+	INSN1(pop,l	,R(esi))
+	INSN1(pop,l	,R(edi))
+	ret
+
diff -urN g10-0.2.3/mpi/i586/mpih-mul3.S g10-0.2.4/mpi/i586/mpih-mul3.S
--- g10-0.2.3/mpi/i586/mpih-mul3.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-mul3.S	Wed Feb 11 03:56:10 1998
@@ -0,0 +1,94 @@
+/* i80586 submul_1 -- Multiply a limb vector with a limb and add
+ *		      the result to a second limb vector.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_submul_1( mpi_ptr_t res_ptr,      (sp + 4)
+ *		     mpi_ptr_t s1_ptr,	     (sp + 8)
+ *		     mpi_size_t s1_size,     (sp + 12)
+ *		     mpi_limb_t s2_limb)     (sp + 16)
+ */
+
+#define res_ptr edi
+#define s1_ptr	esi
+#define size	ecx
+#define s2_limb ebp
+
+	TEXT
+	ALIGN (3)
+	GLOBL	C_SYMBOL_NAME(mpihelp_submul_1)
+C_SYMBOL_NAME(mpihelp_submul_1:)
+
+	INSN1(push,l	,R(edi))
+	INSN1(push,l	,R(esi))
+	INSN1(push,l	,R(ebx))
+	INSN1(push,l	,R(ebp))
+
+	INSN2(mov,l	,R(res_ptr),MEM_DISP(esp,20))
+	INSN2(mov,l	,R(s1_ptr),MEM_DISP(esp,24))
+	INSN2(mov,l	,R(size),MEM_DISP(esp,28))
+	INSN2(mov,l	,R(s2_limb),MEM_DISP(esp,32))
+
+	INSN2(lea,l	,R(res_ptr),MEM_INDEX(res_ptr,size,4))
+	INSN2(lea,l	,R(s1_ptr),MEM_INDEX(s1_ptr,size,4))
+	INSN1(neg,l	,R(size))
+	INSN2(xor,l	,R(ebx),R(ebx))
+	ALIGN (3)
+
+Loop:	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),MEM_INDEX(s1_ptr,size,4))
+
+	INSN1(mul,l	,R(s2_limb))
+
+	INSN2(add,l	,R(eax),R(ebx))
+	INSN2(mov,l	,R(ebx),MEM_INDEX(res_ptr,size,4))
+
+	INSN2(adc,l	,R(edx),$0)
+	INSN2(sub,l	,R(ebx),R(eax))
+
+	INSN2(mov,l	,MEM_INDEX(res_ptr,size,4),R(ebx))
+	INSN1(inc,l	,R(size))
+
+	INSN2(mov,l	,R(ebx),R(edx))
+	INSN1(jnz,	,Loop)
+
+	INSN2(adc,l	,R(ebx),$0)
+	INSN2(mov,l	,R(eax),R(ebx))
+	INSN1(pop,l	,R(ebp))
+	INSN1(pop,l	,R(ebx))
+	INSN1(pop,l	,R(esi))
+	INSN1(pop,l	,R(edi))
+	ret
+
diff -urN g10-0.2.3/mpi/i586/mpih-shift.S g10-0.2.4/mpi/i586/mpih-shift.S
--- g10-0.2.3/mpi/i586/mpih-shift.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-shift.S	Wed Feb 11 04:13:14 1998
@@ -0,0 +1,426 @@
+/* i80586   rshift, lshift
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_lshift)
+C_SYMBOL_NAME(mpihelp_lshift:)
+
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s_ptr */
+	movl	28(%esp),%ebp		/* size */
+	movl	32(%esp),%ecx		/* cnt */
+
+/* We can use faster code for shift-by-1 under certain conditions.  */
+	cmp	$1,%ecx
+	jne	Lnormal
+	leal	4(%esi),%eax
+	cmpl	%edi,%eax
+	jnc	Lspecial		/* jump if s_ptr + 1 >= res_ptr */
+	leal	(%esi,%ebp,4),%eax
+	cmpl	%eax,%edi
+	jnc	Lspecial		/* jump if res_ptr >= s_ptr + size */
+
+Lnormal:
+	leal	-4(%edi,%ebp,4),%edi
+	leal	-4(%esi,%ebp,4),%esi
+
+	movl	(%esi),%edx
+	subl	$4,%esi
+	xorl	%eax,%eax
+	shldl	%cl,%edx,%eax		/* compute carry limb */
+	pushl	%eax			/* push carry limb onto stack */
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+	jz	Lend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+Loop:	movl	-28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	-4(%esi),%edx
+	shldl	%cl,%eax,%ebx
+	shldl	%cl,%edx,%eax
+	movl	%ebx,(%edi)
+	movl	%eax,-4(%edi)
+
+	movl	-8(%esi),%ebx
+	movl	-12(%esi),%eax
+	shldl	%cl,%ebx,%edx
+	shldl	%cl,%eax,%ebx
+	movl	%edx,-8(%edi)
+	movl	%ebx,-12(%edi)
+
+	movl	-16(%esi),%edx
+	movl	-20(%esi),%ebx
+	shldl	%cl,%edx,%eax
+	shldl	%cl,%ebx,%edx
+	movl	%eax,-16(%edi)
+	movl	%edx,-20(%edi)
+
+	movl	-24(%esi),%eax
+	movl	-28(%esi),%edx
+	shldl	%cl,%eax,%ebx
+	shldl	%cl,%edx,%eax
+	movl	%ebx,-24(%edi)
+	movl	%eax,-28(%edi)
+
+	subl	$32,%esi
+	subl	$32,%edi
+	decl	%ebp
+	jnz	Loop
+
+Lend:	popl	%ebp
+	andl	$7,%ebp
+	jz	Lend2
+Loop2:	movl	(%esi),%eax
+	shldl	%cl,%eax,%edx
+	movl	%edx,(%edi)
+	movl	%eax,%edx
+	subl	$4,%esi
+	subl	$4,%edi
+	decl	%ebp
+	jnz	Loop2
+
+Lend2:	shll	%cl,%edx		/* compute least significant limb */
+	movl	%edx,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+/* We loop from least significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.
+*/
+
+Lspecial:
+	movl	(%esi),%edx
+	addl	$4,%esi
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+
+	addl	%edx,%edx
+	incl	%ebp
+	decl	%ebp
+	jz	LLend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+LLoop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	adcl	%eax,%eax
+	movl	%ebx,(%edi)
+	adcl	%edx,%edx
+	movl	%eax,4(%edi)
+
+	movl	8(%esi),%ebx
+	movl	12(%esi),%eax
+	adcl	%ebx,%ebx
+	movl	%edx,8(%edi)
+	adcl	%eax,%eax
+	movl	%ebx,12(%edi)
+
+	movl	16(%esi),%edx
+	movl	20(%esi),%ebx
+	adcl	%edx,%edx
+	movl	%eax,16(%edi)
+	adcl	%ebx,%ebx
+	movl	%edx,20(%edi)
+
+	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	adcl	%eax,%eax
+	movl	%ebx,24(%edi)
+	adcl	%edx,%edx
+	movl	%eax,28(%edi)
+
+	leal	32(%esi),%esi		/* use leal not to clobber carry */
+	leal	32(%edi),%edi
+	decl	%ebp
+	jnz	LLoop
+
+LLend:	popl	%ebp
+	sbbl	%eax,%eax		/* save carry in %eax */
+	andl	$7,%ebp
+	jz	LLend2
+	addl	%eax,%eax		/* restore carry from eax */
+LLoop2: movl	%edx,%ebx
+	movl	(%esi),%edx
+	adcl	%edx,%edx
+	movl	%ebx,(%edi)
+
+	leal	4(%esi),%esi		/* use leal not to clobber carry */
+	leal	4(%edi),%edi
+	decl	%ebp
+	jnz	LLoop2
+
+	jmp	LL1
+LLend2: addl	%eax,%eax		/* restore carry from eax */
+LL1:	movl	%edx,(%edi)		/* store last limb */
+
+	sbbl	%eax,%eax
+	negl	%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_rshift)
+C_SYMBOL_NAME(mpihelp_rshift:)
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s_ptr */
+	movl	28(%esp),%ebp		/* size */
+	movl	32(%esp),%ecx		/* cnt */
+
+/* We can use faster code for shift-by-1 under certain conditions.  */
+	cmp	$1,%ecx
+	jne	Rnormal
+	leal	4(%edi),%eax
+	cmpl	%esi,%eax
+	jnc	Rspecial		/* jump if res_ptr + 1 >= s_ptr */
+	leal	(%edi,%ebp,4),%eax
+	cmpl	%eax,%esi
+	jnc	Rspecial		/* jump if s_ptr >= res_ptr + size */
+
+Rnormal:
+	movl	(%esi),%edx
+	addl	$4,%esi
+	xorl	%eax,%eax
+	shrdl	%cl,%edx,%eax		/* compute carry limb */
+	pushl	%eax			/* push carry limb onto stack */
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+	jz	Rend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+Roop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	shrdl	%cl,%eax,%ebx
+	shrdl	%cl,%edx,%eax
+	movl	%ebx,(%edi)
+	movl	%eax,4(%edi)
+
+	movl	8(%esi),%ebx
+	movl	12(%esi),%eax
+	shrdl	%cl,%ebx,%edx
+	shrdl	%cl,%eax,%ebx
+	movl	%edx,8(%edi)
+	movl	%ebx,12(%edi)
+
+	movl	16(%esi),%edx
+	movl	20(%esi),%ebx
+	shrdl	%cl,%edx,%eax
+	shrdl	%cl,%ebx,%edx
+	movl	%eax,16(%edi)
+	movl	%edx,20(%edi)
+
+	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	shrdl	%cl,%eax,%ebx
+	shrdl	%cl,%edx,%eax
+	movl	%ebx,24(%edi)
+	movl	%eax,28(%edi)
+
+	addl	$32,%esi
+	addl	$32,%edi
+	decl	%ebp
+	jnz	Roop
+
+Rend:	popl	%ebp
+	andl	$7,%ebp
+	jz	Rend2
+Roop2:	movl	(%esi),%eax
+	shrdl	%cl,%eax,%edx		/* compute result limb */
+	movl	%edx,(%edi)
+	movl	%eax,%edx
+	addl	$4,%esi
+	addl	$4,%edi
+	decl	%ebp
+	jnz	Roop2
+
+Rend2:	shrl	%cl,%edx		/* compute most significant limb */
+	movl	%edx,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+/* We loop from least significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.
+*/
+
+Rspecial:
+	leal	-4(%edi,%ebp,4),%edi
+	leal	-4(%esi,%ebp,4),%esi
+
+	movl	(%esi),%edx
+	subl	$4,%esi
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+
+	shrl	$1,%edx
+	incl	%ebp
+	decl	%ebp
+	jz	RLend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+RLoop:	movl	-28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	-4(%esi),%edx
+	rcrl	$1,%eax
+	movl	%ebx,(%edi)
+	rcrl	$1,%edx
+	movl	%eax,-4(%edi)
+
+	movl	-8(%esi),%ebx
+	movl	-12(%esi),%eax
+	rcrl	$1,%ebx
+	movl	%edx,-8(%edi)
+	rcrl	$1,%eax
+	movl	%ebx,-12(%edi)
+
+	movl	-16(%esi),%edx
+	movl	-20(%esi),%ebx
+	rcrl	$1,%edx
+	movl	%eax,-16(%edi)
+	rcrl	$1,%ebx
+	movl	%edx,-20(%edi)
+
+	movl	-24(%esi),%eax
+	movl	-28(%esi),%edx
+	rcrl	$1,%eax
+	movl	%ebx,-24(%edi)
+	rcrl	$1,%edx
+	movl	%eax,-28(%edi)
+
+	leal	-32(%esi),%esi		/* use leal not to clobber carry */
+	leal	-32(%edi),%edi
+	decl	%ebp
+	jnz	RLoop
+
+RLend:	popl	%ebp
+	sbbl	%eax,%eax		/* save carry in %eax */
+	andl	$7,%ebp
+	jz	RLend2
+	addl	%eax,%eax		/* restore carry from eax */
+RLoop2: movl	%edx,%ebx
+	movl	(%esi),%edx
+	rcrl	$1,%edx
+	movl	%ebx,(%edi)
+
+	leal	-4(%esi),%esi		/* use leal not to clobber carry */
+	leal	-4(%edi),%edi
+	decl	%ebp
+	jnz	RLoop2
+
+	jmp	RL1
+RLend2: addl	%eax,%eax		/* restore carry from eax */
+RL1:	movl	%edx,(%edi)		/* store last limb */
+
+	movl	$0,%eax
+	rcrl	$1,%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
diff -urN g10-0.2.3/mpi/i586/mpih-sub1.S g10-0.2.4/mpi/i586/mpih-sub1.S
--- g10-0.2.3/mpi/i586/mpih-sub1.S	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/i586/mpih-sub1.S	Wed Feb 11 03:58:07 1998
@@ -0,0 +1,143 @@
+/* i80586 sub_n -- Sub two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *	Copyright (C) 1992, 1994, 1995 Free Software Foundation, Inc.
+ *	Copyright (c) 1997 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_sub_n( mpi_ptr_t res_ptr,	(sp + 4)
+ *		   mpi_ptr_t s1_ptr,	(sp + 8)
+ *		   mpi_ptr_t s2_ptr,	(sp + 12)
+ *		   mpi_size_t size)	(sp + 16)
+ */
+
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_sub_n)
+C_SYMBOL_NAME(mpihelp_sub_n:)
+
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s1_ptr */
+	movl	28(%esp),%ebp		/* s2_ptr */
+	movl	32(%esp),%ecx		/* size */
+
+	movl	(%ebp),%ebx
+
+	decl	%ecx
+	movl	%ecx,%edx
+	shrl	$3,%ecx
+	andl	$7,%edx
+	testl	%ecx,%ecx		/* zero carry flag */
+	jz	Lend
+	pushl	%edx
+
+	ALIGN (3)
+Loop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	leal	32(%edi),%edi
+
+L1:	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	sbbl	%ebx,%eax
+	movl	4(%ebp),%ebx
+	sbbl	%ebx,%edx
+	movl	8(%ebp),%ebx
+	movl	%eax,-32(%edi)
+	movl	%edx,-28(%edi)
+
+L2:	movl	8(%esi),%eax
+	movl	12(%esi),%edx
+	sbbl	%ebx,%eax
+	movl	12(%ebp),%ebx
+	sbbl	%ebx,%edx
+	movl	16(%ebp),%ebx
+	movl	%eax,-24(%edi)
+	movl	%edx,-20(%edi)
+
+L3:	movl	16(%esi),%eax
+	movl	20(%esi),%edx
+	sbbl	%ebx,%eax
+	movl	20(%ebp),%ebx
+	sbbl	%ebx,%edx
+	movl	24(%ebp),%ebx
+	movl	%eax,-16(%edi)
+	movl	%edx,-12(%edi)
+
+L4:	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	sbbl	%ebx,%eax
+	movl	28(%ebp),%ebx
+	sbbl	%ebx,%edx
+	movl	32(%ebp),%ebx
+	movl	%eax,-8(%edi)
+	movl	%edx,-4(%edi)
+
+	leal	32(%esi),%esi
+	leal	32(%ebp),%ebp
+	decl	%ecx
+	jnz	Loop
+
+	popl	%edx
+Lend:
+	decl	%edx			/* test %edx w/o clobbering carry */
+	js	Lend2
+	incl	%edx
+Loop2:
+	leal	4(%edi),%edi
+	movl	(%esi),%eax
+	sbbl	%ebx,%eax
+	movl	4(%ebp),%ebx
+	movl	%eax,-4(%edi)
+	leal	4(%esi),%esi
+	leal	4(%ebp),%ebp
+	decl	%edx
+	jnz	Loop2
+Lend2:
+	movl	(%esi),%eax
+	sbbl	%ebx,%eax
+	movl	%eax,(%edi)
+
+	sbbl	%eax,%eax
+	negl	%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
diff -urN g10-0.2.3/mpi/mpi-inv.c g10-0.2.4/mpi/mpi-inv.c
--- g10-0.2.3/mpi/mpi-inv.c	Wed Jan 28 11:13:33 1998
+++ g10-0.2.4/mpi/mpi-inv.c	Wed Feb 11 03:38:05 1998
@@ -76,7 +76,7 @@
     mpi_free(t3);
     mpi_free(u);
     mpi_free(v);
-  #else
+  #elif 0
     /* Extended Euclid's algorithm (See TAOPC Vol II, 4.5.2, Alg X)
      * modified according to Michael Penk's solution for Exercice 35 */
 
@@ -155,6 +155,107 @@
     mpi_free(v3);
     mpi_free(t1);
     mpi_free(t2);
+    mpi_free(t3);
+  #else
+    /* Extended Euclid's algorithm (See TAOPC Vol II, 4.5.2, Alg X)
+     * modified according to Michael Penk's solution for Exercice 35
+     * with further enhancement */
+    MPI u, v, u1, u2=NULL, u3, v1, v2=NULL, v3, t1, t2=NULL, t3;
+    unsigned k;
+    int sign;
+    int odd ;
+
+    u = mpi_copy(a);
+    v = mpi_copy(n);
+    for(k=0; !mpi_test_bit(u,0) && !mpi_test_bit(v,0); k++ ) {
+	mpi_rshift(u, u, 1);
+	mpi_rshift(v, v, 1);
+    }
+    odd = mpi_test_bit(v,0);
+
+    u1 = mpi_alloc_set_ui(1);
+    if( !odd )
+	u2 = mpi_alloc_set_ui(0);
+    u3 = mpi_copy(u);
+    v1 = mpi_copy(v);
+    if( !odd ) {
+	v2 = mpi_alloc( mpi_get_nlimbs(u) );
+	mpi_sub( v2, u1, u ); /* U is used as const 1 */
+    }
+    v3 = mpi_copy(v);
+    if( mpi_test_bit(u, 0) ) { /* u is odd */
+	t1 = mpi_alloc_set_ui(0);
+	if( !odd ) {
+	    t2 = mpi_alloc_set_ui(1); t2->sign = 1;
+	}
+	t3 = mpi_copy(v); t3->sign = !t3->sign;
+	goto Y4;
+    }
+    else {
+	t1 = mpi_alloc_set_ui(1);
+	if( !odd )
+	    t2 = mpi_alloc_set_ui(0);
+	t3 = mpi_copy(u);
+    }
+    do {
+	do {
+	    if( !odd ) {
+		if( mpi_test_bit(t1, 0) || mpi_test_bit(t2, 0) ) { /* one is odd */
+		    mpi_add(t1, t1, v);
+		    mpi_sub(t2, t2, u);
+		}
+		mpi_rshift(t1, t1, 1);
+		mpi_rshift(t2, t2, 1);
+		mpi_rshift(t3, t3, 1);
+	    }
+	    else {
+		if( mpi_test_bit(t1, 0) )
+		    mpi_add(t1, t1, v);
+		mpi_rshift(t1, t1, 1);
+		mpi_rshift(t3, t3, 1);
+	    }
+	  Y4:
+	} while( !mpi_test_bit( t3, 0 ) ); /* while t3 is even */
+
+	if( !t3->sign ) {
+	    mpi_set(u1, t1);
+	    if( !odd )
+		mpi_set(u2, t2);
+	    mpi_set(u3, t3);
+	}
+	else {
+	    mpi_sub(v1, v, t1);
+	    sign = u->sign; u->sign = !u->sign;
+	    if( !odd )
+		mpi_sub(v2, u, t2);
+	    u->sign = sign;
+	    sign = t3->sign; t3->sign = !t3->sign;
+	    mpi_set(v3, t3);
+	    t3->sign = sign;
+	}
+	mpi_sub(t1, u1, v1);
+	if( !odd )
+	    mpi_sub(t2, u2, v2);
+	mpi_sub(t3, u3, v3);
+	if( t1->sign ) {
+	    mpi_add(t1, t1, v);
+	    if( !odd )
+		mpi_sub(t2, t2, u);
+	}
+    } while( mpi_cmp_ui( t3, 0 ) ); /* while t3 != 0 */
+    /* mpi_lshift( u3, k ); */
+    mpi_set(x, u1);
+
+    mpi_free(u1);
+    mpi_free(v1);
+    mpi_free(t1);
+    if( !odd ) {
+	mpi_free(u2);
+	mpi_free(v2);
+	mpi_free(t2);
+    }
+    mpi_free(u3);
+    mpi_free(v3);
     mpi_free(t3);
   #endif
 }
diff -urN g10-0.2.3/mpi/mpi-mpow.c g10-0.2.4/mpi/mpi-mpow.c
--- g10-0.2.3/mpi/mpi-mpow.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/mpi/mpi-mpow.c	Wed Feb 11 03:07:11 1998
@@ -0,0 +1,119 @@
+/* mpi-mpow.c  -  MPI functions
+ *	Copyright (c) 1998 by Werner Koch (dd9jn)
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi-internal.h"
+#include "longlong.h"
+#include <assert.h>
+
+static int
+build_index( MPI *exparray, int k, int i, int t )
+{
+    int j, bitno;
+    int index = 0;
+
+    bitno = t-i;
+    for(j=k-1; j >= 0; j-- ) {
+	index <<= 1;
+	if( mpi_test_bit( exparray[j], bitno ) )
+	    index |= 1;
+    }
+    /*log_debug("t=%d i=%d index=%d\n", t, i, index );*/
+    return index;
+}
+
+/****************
+ * RES = (BASE[0] ^ EXP[0]) *  (BASE[1] ^ EXP[1]) * ... * mod M
+ */
+void
+mpi_mulpowm( MPI res, MPI *basearray, MPI *exparray, MPI m)
+{
+    int k;	/* number of elements */
+    int t;	/* bit size of largest exponent */
+    int i, j, idx;
+    MPI *G;	/* table with precomputed values of size 2^k */
+    MPI tmp;
+
+    for(k=0; basearray[k]; k++ )
+	;
+    assert(k);
+    for(t=0, i=0; (tmp=exparray[i]); i++ ) {
+	/*log_mpidump("exp: ", tmp );*/
+	j = mpi_get_nbits(tmp);
+	if( j > t )
+	    t = j;
+    }
+    /*log_mpidump("mod: ", m );*/
+    assert(i==k);
+    assert(t);
+    assert( k < 10 );
+
+    G = m_alloc_clear( (1<<k) * sizeof *G );
+  #if 0
+    /* do the precomputation */
+    G[0] = mpi_alloc_set_ui( 1 );
+    for(i=1; i < (1<<k); i++ ) {
+	for(j=0; j < k; j++ ) {
+	    if( (i & (1<<j) ) ) {
+		if( !G[i] )
+		    G[i] = mpi_copy( basearray[j] );
+		else
+		    mpi_mulm( G[i], G[i], basearray[j], m );
+	    }
+	}
+	if( !G[i] )
+	    G[i] = mpi_alloc(0);
+    }
+  #endif
+    /* and calculate */
+    tmp =  mpi_alloc( mpi_get_nlimbs(m)+1 );
+    mpi_set_ui( res, 1 );
+    for(i = 1; i <= t; i++ ) {
+	mpi_mulm(tmp, res, res, m );
+	idx = build_index( exparray, k, i, t );
+	assert( idx >= 0 && idx < (1<<k) );
+	if( !G[idx] ) {
+	    if( !idx )
+		 G[0] = mpi_alloc_set_ui( 1 );
+	    else {
+		for(j=0; j < k; j++ ) {
+		    if( (idx & (1<<j) ) ) {
+			if( !G[idx] )
+			    G[idx] = mpi_copy( basearray[j] );
+			else
+			    mpi_mulm( G[idx], G[idx], basearray[j], m );
+		    }
+		}
+		if( !G[idx] )
+		    G[idx] = mpi_alloc(0);
+	    }
+	}
+	mpi_mulm(res, tmp, G[idx], m );
+    }
+
+    /* cleanup */
+    m_free(tmp);
+    for(i=0; i < (1<<k); i++ )
+	mpi_free(G[i]);
+    m_free(G);
+}
+
diff -urN g10-0.2.3/po/ChangeLog g10-0.2.4/po/ChangeLog
--- g10-0.2.3/po/ChangeLog	Wed Jan 28 15:39:51 1998
+++ g10-0.2.4/po/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/po/g10.pot g10-0.2.4/po/g10.pot
--- g10-0.2.3/po/g10.pot	Mon Feb  9 15:28:58 1998
+++ g10-0.2.4/po/g10.pot	Wed Feb 11 22:41:15 1998
@@ -1,12 +1,12 @@
 msgid ""
 msgstr ""
-"Date: 1998-02-09 15:28:58+0100\n"
+"Date: 1998-02-11 22:41:15+0100\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=g10 --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
 "Files: util/secmem.c cipher/random.c g10/g10.c g10/pkclist.c g10/keygen.c\n"
 
-#: util/secmem.c:85
+#: util/secmem.c:176
 msgid "Warning: using insecure memory!\n"
 msgstr ""
 
@@ -237,99 +237,99 @@
 msgid "make a clear text signature"
 msgstr ""
 
-#: g10/g10.c:287
+#: g10/g10.c:288
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:290
+#: g10/g10.c:291
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:295
+#: g10/g10.c:296
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:384
+#: g10/g10.c:386
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:388
+#: g10/g10.c:390
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:392
+#: g10/g10.c:394
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:396
+#: g10/g10.c:398
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:400
+#: g10/g10.c:402
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:463
+#: g10/g10.c:460
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
 #. only store the file
-#: g10/g10.c:469
+#: g10/g10.c:466
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:477
+#: g10/g10.c:474
 msgid "--symmetric [filename]"
 msgstr ""
 
 #. encrypt the given file
-#: g10/g10.c:484
+#: g10/g10.c:481
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:497
+#: g10/g10.c:494
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:510
+#: g10/g10.c:507
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:524
+#: g10/g10.c:521
 msgid "--clearsign [filename]"
 msgstr ""
 
 #. sign the key given as argument
-#: g10/g10.c:532
+#: g10/g10.c:529
 msgid "--sign-key username"
 msgstr ""
 
-#: g10/g10.c:540
+#: g10/g10.c:537
 msgid "--edit-sig username"
 msgstr ""
 
-#: g10/g10.c:548
+#: g10/g10.c:545
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#: g10/g10.c:562 g10/g10.c:579 g10/g10.c:618
+#: g10/g10.c:559 g10/g10.c:576 g10/g10.c:615
 msgid "can't open '%s'\n"
 msgstr ""
 
-#: g10/g10.c:584
+#: g10/g10.c:581
 msgid "-k[v][v][v][c] [keyring]"
 msgstr ""
 
 #. generate a key (interactive)
-#: g10/g10.c:589
+#: g10/g10.c:586
 msgid "--gen-key"
 msgstr ""
 
-#: g10/g10.c:595
+#: g10/g10.c:592
 msgid "nyi"
 msgstr ""
 
-#: g10/g10.c:616
+#: g10/g10.c:613
 msgid "[filename]"
 msgstr ""
 
@@ -381,34 +381,34 @@
 msgid "writing self signature\n"
 msgstr ""
 
-#: g10/keygen.c:306
+#: g10/keygen.c:300
 msgid "Key generation can only be used in interactive mode\n"
 msgstr ""
 
-#: g10/keygen.c:308
+#: g10/keygen.c:302
 msgid ""
 "Please select the algorithm to use:\n"
 "   (1) ElGamal is the suggested one.\n"
 "   (2) DSA can only be used for signatures.\n"
 msgstr ""
 
-#: g10/keygen.c:312
+#: g10/keygen.c:306
 msgid "   (3) RSA cannot be used in the U.S.\n"
 msgstr ""
 
-#: g10/keygen.c:321
+#: g10/keygen.c:315
 msgid "Your selection? (1,2,3) "
 msgstr ""
 
-#: g10/keygen.c:323
+#: g10/keygen.c:317
 msgid "Your selection? (1,2) "
 msgstr ""
 
-#: g10/keygen.c:337
+#: g10/keygen.c:331
 msgid "Sorry; DSA is not yet supported.\n"
 msgstr ""
 
-#: g10/keygen.c:350
+#: g10/keygen.c:344
 msgid ""
 "About to generate a new %s keypair.\n"
 "              minimum keysize is  768 bits\n"
@@ -416,39 +416,39 @@
 "    highest suggested keysize is 2048 bits\n"
 msgstr ""
 
-#: g10/keygen.c:358
+#: g10/keygen.c:352
 msgid "What keysize do you want? (1024) "
 msgstr ""
 
-#: g10/keygen.c:364
+#: g10/keygen.c:358
 msgid "DSA does only allow keysizes from 512 to 1024\n"
 msgstr ""
 
-#: g10/keygen.c:366
+#: g10/keygen.c:360
 msgid "keysize too small; 768 is smallest value allowed.\n"
 msgstr ""
 
-#: g10/keygen.c:368
+#: g10/keygen.c:362
 msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
 msgstr ""
 
-#: g10/keygen.c:370
+#: g10/keygen.c:364
 msgid "Are you sure, that you want this keysize? "
 msgstr ""
 
-#: g10/keygen.c:374
+#: g10/keygen.c:368
 msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
 msgstr ""
 
-#: g10/keygen.c:384
+#: g10/keygen.c:378
 msgid "Requested keysize is %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:387 g10/keygen.c:391
+#: g10/keygen.c:381 g10/keygen.c:385
 msgid "rounded up to %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:398
+#: g10/keygen.c:392
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
@@ -457,57 +457,57 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:410
+#: g10/keygen.c:404
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:414
+#: g10/keygen.c:408
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:416
+#: g10/keygen.c:410
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:418
+#: g10/keygen.c:412
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:426
+#: g10/keygen.c:420
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:438
+#: g10/keygen.c:432
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:446
+#: g10/keygen.c:440
 msgid "Comment: "
 msgstr ""
 
 #. no comment is okay
-#: g10/keygen.c:452
+#: g10/keygen.c:446
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:472
+#: g10/keygen.c:466
 msgid ""
 "You selected this USER-ID:\n"
 "    \"%s\"\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:474
+#: g10/keygen.c:468
 msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
 msgstr ""
 
-#: g10/keygen.c:506
+#: g10/keygen.c:500
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:515
+#: g10/keygen.c:509
 msgid ""
 "You don't what a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at anytime,\n"
@@ -515,19 +515,19 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:521
+#: g10/keygen.c:515
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:538
+#: g10/keygen.c:532
 msgid "writing public certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:539
+#: g10/keygen.c:533
 msgid "writing secret certificate to '%s'\n"
 msgstr ""
 
-#: g10/keygen.c:551
+#: g10/keygen.c:545
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -535,10 +535,10 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:618
+#: g10/keygen.c:612
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:629
+#: g10/keygen.c:623
 msgid "Key generation failed: %s\n"
 msgstr ""
diff -urN g10-0.2.3/tools/ChangeLog g10-0.2.4/tools/ChangeLog
--- g10-0.2.3/tools/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/tools/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/tools/Makefile.am g10-0.2.4/tools/Makefile.am
--- g10-0.2.3/tools/Makefile.am	Mon Feb  9 13:12:47 1998
+++ g10-0.2.4/tools/Makefile.am	Wed Feb 11 21:01:56 1998
@@ -3,14 +3,17 @@
 INCLUDES = -I$(top_srcdir)/include
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a ../mpi/libmpi.a ../util/libutil.a
 
-noinst_PROGRAMS = mpicalc bftest
+noinst_PROGRAMS = mpicalc bftest clean-sat
 
 mpicalc_SOURCES = mpicalc.c
 
 bftest_SOURCES = bftest.c
 
+clean_sat_SOURCES  = clean-sat.c
 
-LDADD = @INTLLIBS@  $(needed_libs)
 
-$(PROGRAMS): $(needed_libs)
+mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
+bftest_LDADD = @INTLLIBS@  $(needed_libs)
+
+mpicalc bftest: $(needed_libs)
 
diff -urN g10-0.2.3/tools/Makefile.in g10-0.2.4/tools/Makefile.in
--- g10-0.2.3/tools/Makefile.in	Mon Feb  9 18:04:42 1998
+++ g10-0.2.4/tools/Makefile.in	Wed Feb 11 23:20:14 1998
@@ -89,13 +89,16 @@
 INCLUDES = -I$(top_srcdir)/include
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a ../mpi/libmpi.a ../util/libutil.a
 
-noinst_PROGRAMS = mpicalc bftest
+noinst_PROGRAMS = mpicalc bftest clean-sat
 
 mpicalc_SOURCES = mpicalc.c
 
 bftest_SOURCES = bftest.c
 
-LDADD = @INTLLIBS@  $(needed_libs)
+clean_sat_SOURCES  = clean-sat.c
+
+mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
+bftest_LDADD = @INTLLIBS@  $(needed_libs)
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 CONFIG_CLEAN_FILES = 
@@ -107,27 +110,29 @@
 LDFLAGS = @LDFLAGS@
 LIBS = @LIBS@
 mpicalc_OBJECTS =  mpicalc.o
-mpicalc_LDADD = $(LDADD)
 mpicalc_DEPENDENCIES =  ../cipher/libcipher.a ../util/libutil.a \
 ../mpi/libmpi.a ../util/libutil.a
 mpicalc_LDFLAGS = 
 bftest_OBJECTS =  bftest.o
-bftest_LDADD = $(LDADD)
 bftest_DEPENDENCIES =  ../cipher/libcipher.a ../util/libutil.a \
 ../mpi/libmpi.a ../util/libutil.a
 bftest_LDFLAGS = 
+clean_sat_OBJECTS =  clean-sat.o
+clean_sat_LDADD = $(LDADD)
+clean_sat_DEPENDENCIES = 
+clean_sat_LDFLAGS = 
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
 
 TAR = tar
 GZIP = --best
-SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES)
-OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS)
+SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES) $(clean_sat_SOURCES)
+OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS) $(clean_sat_OBJECTS)
 
 default: all
 
@@ -177,6 +182,10 @@
 	@rm -f bftest
 	$(LINK) $(bftest_LDFLAGS) $(bftest_OBJECTS) $(bftest_LDADD) $(LIBS)
 
+clean-sat: $(clean_sat_OBJECTS) $(clean_sat_DEPENDENCIES)
+	@rm -f clean-sat
+	$(LINK) $(clean_sat_LDFLAGS) $(clean_sat_OBJECTS) $(clean_sat_LDADD) $(LIBS)
+
 tags: TAGS
 
 ID: $(HEADERS) $(SOURCES) $(LISP)
@@ -217,6 +226,7 @@
 	../include/../cipher/rsa.h ../include/../cipher/blowfish.h \
 	../include/../cipher/gost.h ../include/../cipher/elgamal.h \
 	../include/i18n.h
+clean-sat.o clean-sat.lo: clean-sat.c
 mpicalc.o mpicalc.lo: mpicalc.c ../config.h ../include/util.h \
 	../include/types.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h ../include/memory.h ../include/i18n.h
@@ -284,7 +294,7 @@
 maintainer-clean-generic clean mostlyclean distclean maintainer-clean
 
 
-$(PROGRAMS): $(needed_libs)
+mpicalc bftest: $(needed_libs)
 
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
diff -urN g10-0.2.3/tools/clean-sat.c g10-0.2.4/tools/clean-sat.c
--- g10-0.2.3/tools/clean-sat.c	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/tools/clean-sat.c	Wed Feb 11 21:11:47 1998
@@ -0,0 +1,25 @@
+/* clean-sat.c
+ */
+
+#include <stdio.h>
+
+int
+main(int argc, char **argv)
+{
+    int c, c2;
+
+    if( argc > 1 ) {
+	fprintf(stderr, "no arguments, please\n");
+	return 1;
+    }
+
+    while( (c=getchar()) == '\n' )
+	;
+    while( c != EOF ) {
+	putchar(c);
+	c = getchar();
+    }
+
+    return 0;
+}
+
diff -urN g10-0.2.3/util/ChangeLog g10-0.2.4/util/ChangeLog
--- g10-0.2.3/util/ChangeLog	Thu Jan  1 01:00:00 1970
+++ g10-0.2.4/util/ChangeLog	Tue Feb 10 11:57:29 1998
@@ -0,0 +1,5 @@
+Tue Feb 10 11:57:23 1998  Werner Koch  (wk@frodo)
+
+	* ddd/hhhh:
+
+
diff -urN g10-0.2.3/util/Makefile.in g10-0.2.4/util/Makefile.in
--- g10-0.2.3/util/Makefile.in	Mon Feb  9 18:04:32 1998
+++ g10-0.2.4/util/Makefile.in	Wed Feb 11 23:19:50 1998
@@ -109,7 +109,7 @@
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
@@ -196,9 +196,9 @@
 	  || ln $$d/$$file $(distdir)/$$file 2> /dev/null \
 	  || cp -p $$d/$$file $(distdir)/$$file; \
 	done
-argparse.o: argparse.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h ../include/i18n.h
+argparse.o argparse.lo: argparse.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h ../include/i18n.h
 errors.o: errors.c ../include/errors.h
 fileutil.o: fileutil.c ../include/util.h ../include/errors.h \
 	../include/types.h ../include/mpi.h ../include/iobuf.h \
@@ -206,9 +206,9 @@
 iobuf.o iobuf.lo: iobuf.c ../config.h ../include/memory.h \
 	../include/util.h ../include/types.h ../include/errors.h \
 	../include/mpi.h ../include/iobuf.h
-logger.o: logger.c ../include/util.h ../include/types.h \
-	../include/errors.h ../include/mpi.h ../include/iobuf.h \
-	../include/memory.h
+logger.o logger.lo: logger.c ../config.h ../include/util.h \
+	../include/types.h ../include/errors.h ../include/mpi.h \
+	../include/iobuf.h ../include/memory.h
 memory.o: memory.c ../include/types.h ../include/memory.h \
 	../include/util.h ../include/errors.h ../include/mpi.h \
 	../include/iobuf.h
diff -urN g10-0.2.3/util/argparse.c g10-0.2.4/util/argparse.c
--- g10-0.2.3/util/argparse.c	Tue Jan 27 15:52:55 1998
+++ g10-0.2.4/util/argparse.c	Wed Feb 11 19:41:21 1998
@@ -221,10 +221,10 @@
 		    arg->r_opt = -arg->r_opt;
 		if( !opts[index].short_opt )
 		    arg->r_opt = -2;	       /* unknown option */
-		else if( (opts[index].flags & 8) )  /* no optional argument */
-		    arg->r_type = 0;	       /* okay */
-		else			       /* no required argument */
+		else if( (opts[index].flags & 8) ) /* no argument */
 		    arg->r_opt = -3;	       /* error */
+		else			       /* no or optiona argument */
+		    arg->r_type = 0;	       /* okay */
 		break;
 	    }
 	    else if( state == 3 ) {	       /* no argument found */
diff -urN g10-0.2.3/util/iobuf.c g10-0.2.4/util/iobuf.c
--- g10-0.2.3/util/iobuf.c	Wed Feb  4 14:16:59 1998
+++ g10-0.2.4/util/iobuf.c	Tue Feb 10 13:36:46 1998
@@ -313,7 +313,7 @@
     size_t dummy_len;
     int rc=0;
 
-    for( ; a; a = a2 ) {
+    for( ; a && !rc ; a = a2 ) {
 	a2 = a->chain;
 	if( a->usage == 2 && (rc=iobuf_flush(a)) )
 	    log_error("iobuf_flush failed on close: %s\n", g10_errstr(rc));
@@ -721,6 +721,26 @@
     a->nbytes++;
     return c;
 }
+
+
+int
+iobuf_read(IOBUF a, byte *buf, unsigned buflen )
+{
+    int c, n;
+
+    for(n=0 ; n < buflen; n++, buf++ ) {
+	if( (c = iobuf_readbyte(a)) == -1 ) {
+	    if( !n )
+		return -1; /* eof */
+	    break;
+	}
+	else
+	    *buf = c;
+    }
+    return n;
+}
+
+
 
 
 int
diff -urN g10-0.2.3/util/logger.c g10-0.2.4/util/logger.c
--- g10-0.2.3/util/logger.c	Wed Jan 28 10:11:34 1998
+++ g10-0.2.4/util/logger.c	Wed Feb 11 14:21:08 1998
@@ -129,11 +129,19 @@
     abort();
 }
 
+#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 5 )
 void
-log_bug0()
+log_bug0( const char *file, int line, const char *func )
 {
-    log_bug("Ohhhh jeeee ...\n");
+    log_bug("Ohhhh jeeee ... (%s:%d:%s)\n", file, line, func );
 }
+#else
+void
+log_bug0( const char *file, int line )
+{
+    log_bug("Ohhhh jeeee ... (%s:%d)\n", file, line);
+}
+#endif
 
 void
 log_debug( const char *fmt, ... )
diff -urN g10-0.2.3/util/secmem.c g10-0.2.4/util/secmem.c
--- g10-0.2.3/util/secmem.c	Mon Feb  9 12:32:19 1998
+++ g10-0.2.4/util/secmem.c	Wed Feb 11 20:10:52 1998
@@ -61,6 +61,8 @@
 static unsigned max_blocks;
 static unsigned cur_blocks;
 static int disable_secmem;
+static int show_warning;
+static int no_warning;
 
 static void
 lock_pool( void *p, size_t n )
@@ -82,7 +84,7 @@
     if( err ) {
 	if( errno != EPERM )
 	    log_error("cant lock memory: %s\n", strerror(err));
-	log_info(_("Warning: using insecure memory!\n"));
+	show_warning = 1;
     }
 
   #else
@@ -132,6 +134,17 @@
 
 }
 
+void
+secmem_set_flags( unsigned flags )
+{
+    no_warning = flags & 1;
+}
+
+unsigned
+secmem_get_flags(void)
+{
+    return no_warning ? 1:0;
+}
 
 void
 secmem_init( size_t n )
@@ -156,7 +169,12 @@
     int compressed=0;
 
     if( !pool_okay )
-	init_pool(DEFAULT_POOLSIZE);
+	log_bug("secmem not initialized\n");
+    if( show_warning ) {
+	show_warning = 0;
+	if( !no_warning )
+	    log_info(_("Warning: using insecure memory!\n"));
+    }
 
     /* blocks are always a multiple of 32 */
     size += sizeof(MEMBLOCK);
diff -urN g10-0.2.3/util/strgutil.c g10-0.2.4/util/strgutil.c
--- g10-0.2.3/util/strgutil.c	Mon Feb  2 19:33:26 1998
+++ g10-0.2.4/util/strgutil.c	Wed Feb 11 22:39:31 1998
@@ -50,6 +50,28 @@
     *list = sl;
 }
 
+
+
+STRLIST
+strlist_prev( STRLIST head, STRLIST node )
+{
+    STRLIST n;
+
+    for(n=NULL; head && head != node; head = head->next )
+	n = head;
+    return n;
+}
+
+STRLIST
+strlist_last( STRLIST node )
+{
+    if( node )
+	for( ; node->next ; node = node->next )
+	    ;
+    return node;
+}
+
+
 /****************
  * look for the substring SUB in buffer and return a pointer to that
  * substring in BUF or NULL if not found.
